
# main_pi_3d.py
# train & test on ExPI

from curses import A_DIM
import time
import numpy
from numpy import cov
from numpy import trace
from numpy import iscomplexobj
from numpy import asarray
from numpy.random import randint
from scipy.linalg import sqrtm

import numpy as np
import torch
from torch.utils.data import DataLoader
import torch.nn as nn
import torch.optim as optim
from tensorboardX import SummaryWriter

# from IPython import embed
from tqdm import tqdm

from utils.opt import Options
from utils import util, data_utils, vis_2p
from utils.rigid_align import rigid_align_torch
from utils.dataset import pi3d as datasets
from model import AttModel_crossAtt_unshare as AttModel
from model import Classifier as Classif

from keras.models import Sequential
from keras.optimizers import RMSprop
from keras.optimizers import Adam
from keras.layers import Input, Dense, Flatten, TimeDistributed, LSTM, Masking, concatenate, Dropout, Lambda, Bidirectional, Activation, BatchNormalization, Reshape, Add
from keras.constraints import unit_norm
from keras.regularizers import l1, l2
from keras.utils import to_categorical
# from datasets.SBU_data_batch import Dataloader
import numpy as np
from keras.engine import *
from tensorflow.python.ops import math_ops
import keras.backend as K
import tensorflow as tf
# torch.autograd.set_detect_anomaly(True)
tf.enable_eager_execution()

##SCA code here


from json import encoder
from keras.models import Sequential
from keras.optimizers import RMSprop
from keras.layers import Input, Dense, Flatten, TimeDistributed, LSTM, Masking, concatenate, Dropout, Lambda, Bidirectional, Activation, BatchNormalization, Reshape, Add
from keras.constraints import unit_norm
from keras.regularizers import l1, l2
from keras.utils import to_categorical
# from datasets.SBU_data_batch import Dataloader
import numpy as np
from keras.engine import *
from tensorflow.python.ops import math_ops
import keras.backend as K
import tensorflow as tf
from attention_decoder_lstm_modified_state import AttentionDecoder
import copy
tf.enable_eager_execution()
#anno2.py
USE_CUDA = torch.cuda.is_available()
DEVICE=torch.device('cuda:0') # or set to 'cpu'
print("CUDA:", USE_CUDA)
print(DEVICE)

seed = 42
np.random.seed(seed)
torch.manual_seed(seed)
torch.cuda.manual_seed(seed)

import numpy as np
import torch
import torch.nn as nn
import torch.nn.functional as F
import math, copy, time
import matplotlib.pyplot as plt
from torch.nn.utils.rnn import pack_padded_sequence, pad_packed_sequence
tf.enable_eager_execution()
tf.enable_eager_execution()

#put trans here

import numpy as np
import torch
import torch.nn as nn
import torch.nn.functional as F
import math, copy, time
from torch.autograd import Variable
import matplotlib.pyplot as plt
import seaborn
# seaborn.set_context(context="talk")
# %matplotlib inline

# global flagenc 

flagenc = 0

lastposbias = 0

transenc = 0
def piecewise_index(relative_position, alpha, beta, gamma, dtype):
    rp_abs = relative_position.abs()
    mask = rp_abs <= alpha
    not_mask = ~mask
    rp_out = relative_position[not_mask]
    rp_abs_out = rp_abs[not_mask]
    y_out = (torch.sign(rp_out)* (alpha +
                                 torch.log(rp_abs_out/alpha)/
                                 math.log(gamma/alpha)*
                                 (beta - alpha)).round().clip(max=beta)).to(dtype)
    idx = relative_position.clone()
    if idx.dtype in [torch.float32,torch.float64]:
        idx = idx.round().to(dtype)

    idx[not_mask] = y_out
    return idx

class PositionalEncoding2(nn.Module):
    def __init__(self, n_functions):
        super(PositionalEncoding2, self).__init__()

        self.register_buffer('frequencies', 2.0 ** torch.arange(n_functions))

    def forward(self, x):
        """
        Args:
            x: tensor of shape [..., dim]

        Returns:
            embedding: a temporal embedding of `x` of shape [..., n_functions * dim * 2]
        """
        freq = (x[..., None] * self.frequencies).view(*x.shape[:-1], -1)

        embedding = torch.zeros(*freq.shape[:-1], freq.shape[-1] * 2).cuda()
        embedding[..., 0::2] = freq.sin()
        embedding[..., 1::2] = freq.cos()

        return embedding

class SirenBlock(nn.Module):
    def __init__(self, in_features, out_features, w0=30, c=6, is_first=False, use_bias=True, activation=None):
        super(SirenBlock, self).__init__()

        self.in_features = in_features
        self.is_first = is_first

        weight = torch.zeros(out_features, in_features)
        bias = torch.zeros(out_features) if use_bias else None
        self.init(weight, bias, c=c, w0=w0)

        self.weight = nn.Parameter(weight)
        self.bias = nn.Parameter(bias) if use_bias else None
        self.activation = Sine(w0) if activation is None else activation

    def init(self, weight, bias, c, w0):
        n = self.in_features

        w_std = (1 / n) if self.is_first else (np.sqrt(c / n) / w0)
        weight.uniform_(-w_std, w_std)

        if bias is not None:
            bias.uniform_(-w_std, w_std)

    def forward(self, x):
        out = F.linear(x, self.weight, self.bias)

        return self.activation(out)


class FCBlock(nn.Module):
    def __init__(self, in_features, out_features, norm_layer=False, activation=None):
        super(FCBlock, self).__init__()

        self.fc = nn.Linear(in_features, out_features)
        self.residual = (in_features == out_features)  # when the input and output have the same dimensions, build a residual block
        self.norm_layer = nn.LayerNorm(out_features) if norm_layer else None
        self.activation = nn.ReLU(inplace=True) if activation is None else activation
        dropout = 0.1
        self.dropout = nn.Dropout(dropout)

    def forward(self, x):
        """
        Args:
            x: (B, T, D), features are in the last dimension.
        """
        out = self.fc(x)

        if self.norm_layer is not None:
            out = self.norm_layer(out)

        if self.residual:
            return self.activation(out) + x

        # return self.activation(out)
        return self.dropout(self.activation(out))
    
class EncoderDecoder2(nn.Module):
    """
    A standard Encoder-Decoder architecture. Base for this and many 
    other models.
    """
    def __init__(self, encoder, decoder, src_embed, tgt_embed, generator):
        super(EncoderDecoder2, self).__init__()
        self.encoder = encoder
        self.decoder = decoder
        self.src_embed = src_embed
        self.tgt_embed = tgt_embed
        self.generator = generator
        self.relu = torch.nn.ReLU()
        self.fl = nn.Linear(128,18*3)
    
        
        self.bandwidth = 7
        if self.bandwidth != 0:
            self.positional_encoding = PositionalEncoding2(self.bandwidth)
            embedding_dim = self.bandwidth * 2
        else:
            embedding_dim = 1

        global_z = 50
        hidden_neuron = 256
        local_z = 18*3 + 15
        skip_connection = True
        siren = False
        norm_layer = True
        hidden_neuron = hidden_neuron
        in_features = 1 + local_z if siren else embedding_dim + local_z
        local_in_features = hidden_neuron + in_features if skip_connection else hidden_neuron
        global_in_features = local_in_features + global_z if skip_connection else hidden_neuron
        local_output = 50

        layers = [
            SirenBlock(in_features, hidden_neuron, is_first=True) if siren else FCBlock(in_features, hidden_neuron, norm_layer=norm_layer),
            SirenBlock(local_in_features, hidden_neuron) if siren else FCBlock(local_in_features, hidden_neuron, norm_layer=norm_layer),
            SirenBlock(local_in_features, hidden_neuron) if siren else FCBlock(local_in_features, hidden_neuron, norm_layer=norm_layer),
            SirenBlock(local_in_features, hidden_neuron) if siren else FCBlock(local_in_features, hidden_neuron, norm_layer=norm_layer),
            SirenBlock(local_in_features, hidden_neuron) if siren else FCBlock(local_in_features, hidden_neuron, norm_layer=norm_layer),
            SirenBlock(local_in_features, hidden_neuron) if siren else FCBlock(local_in_features, hidden_neuron, norm_layer=norm_layer),
            SirenBlock(local_in_features, hidden_neuron) if siren else FCBlock(local_in_features, hidden_neuron, norm_layer=norm_layer),
            SirenBlock(local_in_features, hidden_neuron) if siren else FCBlock(local_in_features, hidden_neuron, norm_layer=norm_layer),
            SirenBlock(global_in_features, hidden_neuron) if siren else FCBlock(global_in_features, hidden_neuron, norm_layer=norm_layer),
            SirenBlock(global_in_features, hidden_neuron) if siren else FCBlock(global_in_features, hidden_neuron, norm_layer=norm_layer),
            SirenBlock(global_in_features, hidden_neuron) if siren else FCBlock(global_in_features, hidden_neuron, norm_layer=norm_layer)
        ]
        self.mlp = nn.ModuleList(layers)
        self.skip_layers = [] if not skip_connection else list(range(1, len(self.mlp)))
        self.local_layers = list(range(8))
        self.local_linear = nn.Sequential(nn.Linear(hidden_neuron, local_output))


    def forward(self, src, relenc, tgt, src_mask, tgt_mask):
        "Take in and process masked src and target sequences."
        srcskeleton = src[:,:,:18*3]
        srcgli = src[:,:,(-15):]
        srcact = src[:,:,18*3:(-15)] 
        src = torch.cat([srcskeleton,srcgli],axis=-1)
        b_size = src.shape[0]
        length = src.shape[1]
        step = 1
        # generate f(t; z)
        t = torch.arange(start=0, end=length, step=step).unsqueeze(0)  # (1, T)
        t = t / (length * 2) - 1  # map t to [-1, 1]
        t = t.expand(b_size, -1).unsqueeze(-1).cuda()  # (B, T, 1)

        if self.bandwidth != 0:
            t = self.positional_encoding(t)
        # print(t.shape,"T2")
        if src is not None:
            x = torch.cat([t, src], dim=-1)
        else:
            x = t
        
        skip_in = x
        for i in self.local_layers:
            if i in self.skip_layers:
                x = torch.cat((x, skip_in), dim=-1)
            x = self.mlp[i](x)
        local_output = self.local_linear(x)
        src = torch.cat([local_output,srcact],axis=-1)
        
        global transenc
        
        transenc = self.encode(src,relenc ,src_mask)
        y =self.decode(self.encode(src,relenc ,src_mask), src_mask,
                            tgt, tgt_mask)
        y = self.fl(y)
        
        return y
    
    def encode(self, src, relenc,src_mask):
        return self.encoder(self.src_embed(src),relenc,src_mask)
    
    def decode(self, memory, src_mask, tgt, tgt_mask):
        return self.decoder(self.tgt_embed(tgt), memory, src_mask, tgt_mask)

class Generator(nn.Module):
    "Define standard linear + softmax generation step."
    def __init__(self, d_model, vocab):
        super(Generator, self).__init__()
        self.proj = nn.Linear(d_model, vocab)

    def forward(self, x):
        return F.log_softmax(self.proj(x), dim=-1)

def clones(module, N):
    "Produce N identical layers."
    return nn.ModuleList([copy.deepcopy(module) for _ in range(N)])

class Encoder2(nn.Module):
    "Core encoder is a stack of N layers"
    def __init__(self, layer, N):
        super(Encoder2, self).__init__()
        self.layers = clones(layer, N)
        self.norm = LayerNorm(layer.size)
        
    
    def forward(self, x, relenc,mask):
        "Pass the input (and mask) through each layer in turn."
        for layer in self.layers:
            x = layer(x, relenc, mask)
        return self.norm(x)

class LayerNorm(nn.Module):
    "Construct a layernorm module (See citation for details)."
    def __init__(self, features, eps=1e-6):
        super(LayerNorm, self).__init__()
        self.a_2 = nn.Parameter(torch.ones(features))
        self.b_2 = nn.Parameter(torch.zeros(features))
        self.eps = eps

    def forward(self, x):
        mean = x.mean(-1, keepdim=True)
        std = x.std(-1, keepdim=True)
        return self.a_2 * (x - mean) / (std + self.eps) + self.b_2

class SublayerConnection(nn.Module):
    """
    A residual connection followed by a layer norm.
    Note for code simplicity the norm is first as opposed to last.
    """
    def __init__(self, size, dropout):
        super(SublayerConnection, self).__init__()
        self.norm = LayerNorm(size)
        self.dropout = nn.Dropout(dropout)

    def forward(self, x, sublayer):
        "Apply residual connection to any sublayer with the same size."
        return x + self.dropout(sublayer(self.norm(x)))

class EncoderLayer(nn.Module):
    "Encoder is made up of self-attn and feed forward (defined below)"
    def __init__(self, size, self_attn, feed_forward, dropout):
        super(EncoderLayer, self).__init__()
        self.self_attn = self_attn
        self.feed_forward = feed_forward
        self.sublayer = clones(SublayerConnection(size, dropout), 2)
        self.size = size



    def forward(self, x,relenc, mask):
        "Follow Figure 1 (left) for connections."
        x = self.sublayer[0](x, lambda x: self.self_attn(x, x, x, relenc,mask))
        return self.sublayer[1](x, self.feed_forward)

class Decoder2(nn.Module):
    "Generic N layer decoder with masking."
    def __init__(self, layer, N):
        super(Decoder2, self).__init__()
        self.layers = clones(layer, N)
        self.norm = LayerNorm(layer.size)

        
    def forward(self, x, memory, src_mask, tgt_mask):
        for layer in self.layers:
            x = layer(x, memory, src_mask, tgt_mask)

        return self.norm(x)

class DecoderLayer(nn.Module):
    "Decoder is made of self-attn, src-attn, and feed forward (defined below)"
    def __init__(self, size, self_attn, src_attn, feed_forward, dropout):
        super(DecoderLayer, self).__init__()
        self.size = size
        self.self_attn = self_attn
        self.src_attn = src_attn
        self.feed_forward = feed_forward
        self.sublayer = clones(SublayerConnection(size, dropout), 3)
 
    def forward(self, x, memory, src_mask, tgt_mask):
        "Follow Figure 1 (right) for connections."
        m = memory
        x = self.sublayer[0](x, lambda x: self.self_attn(x, x, x, tgt_mask))
        x = self.sublayer[1](x, lambda x: self.src_attn(x, m, m, src_mask))
        return self.sublayer[2](x, self.feed_forward)

def subsequent_mask(size):
    "Mask out subsequent positions."
    attn_shape = (1, size, size)
    subsequent_mask = np.triu(np.ones(attn_shape), k=1).astype('uint8')
    return torch.from_numpy(subsequent_mask) == 0



def attention(query, key, value, mask=None, dropout=None):
    "Compute 'Scaled Dot Product Attention'"
    d_k = query.size(-1)
    scores = torch.matmul(query, key.transpose(-2, -1)) \
             / math.sqrt(d_k)
    if mask is not None:
        scores = scores.masked_fill(mask == 0, -1e9)
    p_attn = F.softmax(scores, dim = -1)
    if dropout is not None:
        p_attn = dropout(p_attn)
    return torch.matmul(p_attn, value), p_attn

def attentionrel(query, key, value,relencq,relenck,relencv,mask=None, dropout=None):
    "Compute 'Scaled Dot Product Attention'"
    d_k = query.size(-1)
    a =torch.matmul(query,relencq.transpose(-2,-1))
    b = torch.matmul(relenck,key.transpose(-2,-1))
    pos_bias = a + b
    global flagenc 
    global lastposbias
    flagenc = flagenc + 1
    if(flagenc==600):
        lastposbias = pos_bias
        lastposbias.retain_grad()
    scores = (torch.matmul(query, key.transpose(-2, -1)) + pos_bias) \
             / math.sqrt(d_k)
    if mask is not None:
        scores = scores.masked_fill(mask == 0, -1e9)
    
    p_attn = F.softmax(scores, dim = -1)
    if dropout is not None:
        p_attn = dropout(p_attn)
    return torch.matmul(p_attn, value+relencv), p_attn

class MultiHeadedAttention(nn.Module):
    def __init__(self, h, d_model, dropout=0.1):
        "Take in model size and number of heads."
        super(MultiHeadedAttention, self).__init__()
        assert d_model % h == 0
        # We assume d_v always equals d_k
        self.d_k = d_model // h
        self.h = h
        self.linears = clones(nn.Linear(d_model, d_model), 4)
        self.attn = None
        self.dropout = nn.Dropout(p=dropout)
        
    def forward(self, query, key, value, mask=None):
        "Implements Figure 2"
        if mask is not None:
            # Same mask applied to all h heads.
            mask = mask.unsqueeze(1)
        nbatches = query.size(0)
        
        # 1) Do all the linear projections in batch from d_model => h x d_k 
#         print(query.shape,key.shape,value.shape,"before linear trans")
        query, key, value = \
            [l(x).view(nbatches, -1, self.h, self.d_k).transpose(1, 2)
             for l, x in zip(self.linears, (query, key, value))]
        
        # 2) Apply attention on all the projected vectors in batch. 
#         print(query.shape,key.shape,value.shape,mask.shape,"attention stuff here")
        x, self.attn = attention(query, key, value, mask=mask, 
                                 dropout=self.dropout)
#         print(query.shape,key.shape,value.shape,mask.shape,"later attention stuff here")
        # 3) "Concat" using a view and apply a final linear. 
        x = x.transpose(1, 2).contiguous() \
             .view(nbatches, -1, self.h * self.d_k)
        return self.linears[-1](x)

class MultiHeadedAttentionRel(nn.Module):
    def __init__(self, h, d_model, dropout=0.1):
        "Take in model size and number of heads."
        super(MultiHeadedAttentionRel, self).__init__()
        assert d_model % h == 0
        # We assume d_v always equals d_k
        self.d_k = d_model // h
        self.h = h
        self.linears = clones(nn.Linear(d_model, d_model), 4)
        self.attn = None
        self.dropout = nn.Dropout(p=dropout)
        # self.relfeat = 15*15
        self.relfeat = 15*30
        self.linearrelposq = nn.Linear(self.relfeat,d_model)
        self.linearrelposk = nn.Linear(self.relfeat,d_model)
        self.linearrelposv = nn.Linear(self.relfeat,d_model)
        
    def forward(self, query, key, value,relenc, mask=None):
        "Implements Figure 2"
        if mask is not None:
            # Same mask applied to all h heads.
            mask = mask.unsqueeze(1)
        nbatches = query.size(0)
        
        query, key, value = \
            [l(x).view(nbatches, -1, self.h, self.d_k).transpose(1, 2)
             for l, x in zip(self.linears, (query, key, value))]
        relencq = self.linearrelposq(relenc).view(nbatches, -1, self.h, self.d_k).transpose(1, 2)
        relenck = self.linearrelposk(relenc).view(nbatches, -1, self.h, self.d_k).transpose(1, 2)
        relencv = self.linearrelposv(relenc).view(nbatches, -1, self.h, self.d_k).transpose(1, 2)
        x, self.attn = attentionrel(query, key, value,relencq,relenck,relencv, mask=mask, 
                                 dropout=self.dropout)
        x = x.transpose(1, 2).contiguous() \
             .view(nbatches, -1, self.h * self.d_k)
        return self.linears[-1](x)

class PositionwiseFeedForward(nn.Module):
    "Implements FFN equation."
    def __init__(self, d_model, d_ff, dropout=0.1):
        super(PositionwiseFeedForward, self).__init__()
        self.w_1 = nn.Linear(d_model, d_ff)
        self.w_2 = nn.Linear(d_ff, d_model)
        self.dropout = nn.Dropout(dropout)

    def forward(self, x):
        return self.w_2(self.dropout(F.relu(self.w_1(x))))

class Embeddings(nn.Module):
    def __init__(self, d_model, vocab):
        super(Embeddings, self).__init__()
        self.lut1 = nn.Linear(vocab, d_model)
        self.d_model = d_model

    def forward(self, x):
        y = self.lut1(x)*math.sqrt(self.d_model)
        return y
    

class PositionalEncoding(nn.Module):
    "Implement the PE function."
    def __init__(self, d_model, dropout, max_len=5000):
        super(PositionalEncoding, self).__init__()
        self.dropout = nn.Dropout(p=dropout)
        
        # Compute the positional encodings once in log space.
        pe = torch.zeros(max_len, d_model)
        position = torch.arange(0, max_len).unsqueeze(1)
        div_term = torch.exp(torch.arange(0, d_model, 2) *
                             -(math.log(10000.0) / d_model))
        pe[:, 0::2] = torch.sin(position * div_term)
        pe[:, 1::2] = torch.cos(position * div_term)
        pe = pe.unsqueeze(0)
        self.register_buffer('pe', pe)
        
    def forward(self, x):
        a,b,c = Variable(self.pe[:, :x.size(1)], 
                         requires_grad=False).repeat(1,1,18*3).shape
        q,w,e = x.shape
        x = x + Variable(self.pe[:, :x.size(1)], 
                         requires_grad=False)
        return self.dropout(x)

def make_modeltrans(src_vocab, tgt_vocab, N=6, 
               d_model=512, d_ff=2048, h=8, dropout=0.1):
    "Helper: Construct a model from hyperparameters."
    
    d_model=128
    h=4
    c = copy.deepcopy
    attn = MultiHeadedAttention(h, d_model)
    attnRel = MultiHeadedAttentionRel(h, d_model)
    ff = PositionwiseFeedForward(d_model, d_ff, dropout)
    position = PositionalEncoding(d_model, dropout)
    
    model = EncoderDecoder2(
        Encoder2(EncoderLayer(d_model, c(attnRel), c(ff), dropout), N),
        Decoder2(DecoderLayer(d_model, c(attn), c(attn), 
                             c(ff), dropout), N),
        # nn.Sequential(Embeddings(d_model, src_vocab+7+36+15+15), c(position)),
        nn.Sequential(Embeddings(d_model, 57), c(position)),
        nn.Sequential(Embeddings(d_model, tgt_vocab), c(position)),
        Generator(d_model, tgt_vocab))
    
    # This was important from their code. 
    # Initialize parameters with Glorot / fan_avg.
    for p in model.parameters():
        if p.dim() > 1:
            nn.init.xavier_uniform(p)
    return model

#end trans here


#anno2.py
#anno2.py model
class EncoderDecoder(nn.Module):
    """
    A standard Encoder-Decoder architecture. Base for this and many 
    other models.
    """
    def __init__(self, encoder, decoder, src_embed, trg_embed, generator):
        super(EncoderDecoder, self).__init__()
        self.encoder = encoder
        self.decoder = decoder
        self.src_embed = src_embed
        self.trg_embed = trg_embed
        self.generator = generator
        
    def forward(self, src):
        """Take in and process masked src and target sequences."""
        self.encoder.cuda()
        encoder_hidden, encoder_final = self.encode(src)
        return self.decode(encoder_hidden, encoder_final)
    
    # def encode(self, src, src_mask, src_lengths):
    #     return self.encoder(self.src_embed(src), src_mask, src_lengths)
    
    def encode(self, src):
        return self.encoder(src)
    
    def decode(self, encoder_hidden, encoder_final,decoder_hidden=None):
        return self.decoder( encoder_hidden, encoder_final,
                             hidden=decoder_hidden)


# To keep things easy we also keep the `Generator` class the same. 
# It simply projects the pre-output layer ($x$ in the `forward` function below) to obtain the output layer, so that the final dimension is the target vocabulary size.

# In[4]:


class Generator(nn.Module):
    """Define standard linear + softmax generation step."""
    def __init__(self, hidden_size, vocab_size):
        super(Generator, self).__init__()
        self.proj = nn.Linear(hidden_size, vocab_size, bias=False)

    def forward(self, x):
        return F.log_softmax(self.proj(x), dim=-1)





class Encoder(nn.Module):
    """Encodes a sequence of word embeddings"""
    def __init__(self, input_size, hidden_size, num_layers=1, dropout=0.):
        super(Encoder, self).__init__()
        self.num_layers = num_layers
        self.hidden_size = hidden_size
        self.rnn = []
        for i in range(7):
            if(i!=6):
                self.rnn.append(nn.GRU(3*3,hidden_size,num_layers,batch_first=True,bidirectional=True,dropout=dropout))
            else:
                self.rnn.append(nn.GRU(7,hidden_size,num_layers,batch_first=True,bidirectional=True,dropout=dropout))
        self.rnn = nn.ModuleList(self.rnn)
        # self.rnn = nn.GRU(input_size, hidden_size, num_layers, 
        #                   batch_first=True, bidirectional=True, dropout=dropout)
        
    def forward(self, x):
        """
        Applies a bidirectional GRU to sequence of embeddings x.
        The input mini-batch x needs to be sorted by length.
        x should have dimensions [batch, time, dim].
        """
        # x = x.cuda()
        # packed = pack_padded_sequence(x, lengths, batch_first=True)
        # print(self.hidden_size)
        # print('hid')
        # print(x.size())
        # x = torch.randn((32,9,61)).cuda()
        # print(x.size())
        new_slic_idx = [it*3 for it in [0, 3, 3, 3, 3, 3,3]]
        new_slic_idx.append(7)
        new_slic_idx = np.cumsum(new_slic_idx)

        def slice(x, index1, index2):
            return x[:, :, index1:index2]
        i=-1
        finalall = []
        outputall = []
        for slc_id in range(0, len(new_slic_idx) - 1):
            i+=1
        # for slc_id in range(0, len(new_slic_idx)):
            # print(new_slic_idx[slc_id])
            # print(new_slic_idx[slc_id+1])
            length = len(new_slic_idx)
            # print(slc_id)
            # print(length)
            # if(slc_id == (length-1)):
            #     sliced_data = Lambda(slice, arguments={'index1': new_slic_idx[0], 'index2':new_slic_idx[length-2]})(encoder_inputs_A)
            # else:
            index1 = new_slic_idx[slc_id]
            index2 = new_slic_idx[slc_id+1]
            # print(i)
            sliced_data = slice(x,index1,index2).cuda()
            # print(sliced_data.size())
            # print("Slice",i,"here")
            output, final = self.rnn[i](sliced_data)
            # output, _ = pad_packed_sequence(output, batch_first=True)

            # we need to manually concatenate the final states for both directions
            fwd_final = final[0:final.size(0):2]
            bwd_final = final[1:final.size(0):2]
            final = torch.cat([fwd_final, bwd_final], dim=2)  # [num_layers, batch, 2*dim]
            if(i==0):
                finalall = final
                outputall = output
            else:
                finalall = torch.cat([finalall,final],dim=-1)
                outputall = torch.cat([outputall,output],dim=-1)
            
        # print(outputall.size())
        # print(finalall.size())
        # exit()
        # output, final = self.rnn(x)
        # output, _ = pad_packed_sequence(output, batch_first=True)
        # print(final[0].size())
        # we need to manually concatenate the final states for both directions
        # fwd_final = final[0:final.size(0):2]
        # bwd_final = final[1:final.size(0):2]
        # final = torch.cat([fwd_final, bwd_final], dim=2)  # [num_layers, batch, 2*dim]

        # output = torch.cat([output,output],dim=2)
        # final = torch.cat([final,final],dim=2)
        # print(output.dtype)
        # print(final.dtype)
        # print("ENCODER HERE")
        # return output, final
        return outputall, finalall

class Discrim(nn.Module):
    """Encodes a sequence of word embeddings"""
    def __init__(self, hidden_size):
        super(Discrim, self).__init__()
        self.input_size = 18*3
        self.seqlen = 50
        self.lstm1 = nn.LSTM(self.input_size,hidden_size,batch_first=True,num_layers=2,bidirectional=True)
        self.linear1 = nn.Linear(self.seqlen*hidden_size*2,8)
        self.soft = nn.Softmax()
    def forward(self, x):
        """
        Applies a bidirectional GRU to sequence of embeddings x.
        The input mini-batch x needs to be sorted by length.
        x should have dimensions [batch, time, dim].
        """
        output, _= self.lstm1(x)
        # print(output.size())
        a , b , c = output.size()
        output = torch.reshape(output,(a,b*c))
        # print(output.size())
        outputbin = self.linear1(output)
        # print(outputbin.size())
        outputbin = outputbin.squeeze(1)
        # print(outputbin.size())
        outputbin = self.soft(outputbin)
        return outputbin
        
class ActRec(nn.Module):
    """Encodes a sequence of word embeddings"""
    def __init__(self, hidden_size):
        super(ActRec, self).__init__()
        self.input_size = 18*3
        self.seqlen = 50
        self.lstm1 = nn.LSTM(self.input_size,hidden_size,batch_first=True,num_layers=2,bidirectional=True)
        self.linear1 = nn.Linear(self.seqlen*hidden_size*2,500)
        self.linear2 = nn.Linear(500,500)
        self.linear3 = nn.Linear(500,7)
        self.relu = nn.ReLU()
        self.soft = nn.Softmax()
    def forward(self, x):
        output, _= self.lstm1(x)
        a , b , c = output.size()
        output = torch.reshape(output,(a,b*c))
        outputbin = self.linear1(output)
        outputbin = self.relu(outputbin)
        outputbin = self.linear2(outputbin)
        linear2l = outputbin
        outputbin = self.relu(outputbin)
        outputbin = self.linear3(outputbin)
        outputbin = outputbin.squeeze(1)
        return [outputbin,linear2l]




class Decoder(nn.Module):
    """A conditional RNN decoder with attention."""
    
    def __init__(self, emb_size, hidden_size, attention, num_layers=1, dropout=0.5,
                 bridge=True):
        super(Decoder, self).__init__()
        self.emb_size = hidden_size
        emb_size = hidden_size
        self.hidden_size = hidden_size
        self.num_layers = num_layers
        self.attention = attention
        self.dropout = dropout


        self.rnn = nn.GRU(emb_size + 2*hidden_size*7, hidden_size, num_layers,
                          batch_first=True, dropout=dropout)
                 
        self.bridge = nn.Linear(2*hidden_size*7, hidden_size, bias=True) if bridge else None

        self.dropout_layer = nn.Dropout(p=dropout)
        self.pre_output_layer = nn.Linear(hidden_size + 2*hidden_size*7 + emb_size,
                                          hidden_size, bias=False)
        self.pre_final = nn.Linear(hidden_size,hidden_size,bias=True)
        self.final = nn.Linear(hidden_size,54,bias=True)
        self.relu = nn.ReLU()
        # self.pre_output_layer = nn.Linear(hidden_size + 2*hidden_size*2 + emb_size,
        #                                   1, bias=False)

    def forward_step(self, prev_embed, encoder_hidden, proj_key, hidden):
        """Perform a single decoder step (1 word)"""

        # compute context vector using attention mechanism
        query = hidden[-1].unsqueeze(1)  # [#layers, B, D] -> [B, 1, D]
        context, attn_probs = self.attention(
            query=query, proj_key=proj_key,
            value=encoder_hidden)
        rnn_input = torch.cat([prev_embed, context], dim=2)
        output, hidden  = self.rnn(rnn_input, hidden)
        
        pre_output = torch.cat([prev_embed, output, context], dim=2)
        pre_output = self.dropout_layer(pre_output)
        pre_output = self.pre_output_layer(pre_output)

        return output, hidden, pre_output
    
    def forward(self, encoder_hidden, encoder_final, 
                hidden=None, max_len=None):
        """Unroll the decoder one step at a time."""
        a , b , c = encoder_hidden.size()
        max_len = b
        prev_embed = 0
        # initialize decoder hidden state
        if hidden is None:
            hidden , prev_embed = self.init_hidden(encoder_final)
            # print(hidden.size())
        proj_key = self.attention.key_layer(encoder_hidden)
        
        # here we store all intermediate hidden states and pre-output vectors
        decoder_states = []
        pre_output_vectors = []
        
        # unroll the decoder RNN for max_len steps
        for i in range(max_len):
            output, hidden, pre_output = self.forward_step(
              prev_embed, encoder_hidden, proj_key, hidden)
            prev_embed = pre_output
            decoder_states.append(output)
            pre_output_vectors.append(pre_output)

        decoder_states = torch.cat(decoder_states, dim=1)
        pre_output_vectors = torch.cat(pre_output_vectors, dim=1)
        pre_output_vectors = self.pre_final(pre_output_vectors)
        pre_output_vectors = self.relu(pre_output_vectors)
        pre_output_vectors = self.final(pre_output_vectors)
        pre_output_vectors = pre_output_vectors.squeeze(2)
        return decoder_states, hidden, pre_output_vectors  # [B, N, D]

    def init_hidden(self, encoder_final):
        """Returns the initial decoder state,
        conditioned on the final encoder state."""

        if encoder_final is None:
            return None  # start with zeros
        a , b , c = encoder_final.size()
        # print(a,b,c)
        x0 = torch.zeros((b,1,self.emb_size)).cuda()
        
        return torch.tanh(self.bridge(encoder_final)), x0            



class BahdanauAttention(nn.Module):
    """Implements Bahdanau (MLP) attention"""
    
    def __init__(self, hidden_size, key_size=None, query_size=None):
        super(BahdanauAttention, self).__init__()
        
        # We assume a bi-directional encoder so key_size is 2*hidden_size
        # key_size = 2 * hidden_size if key_size is None else key_size
        key_size = 7*2 * hidden_size if key_size is None else key_size
        query_size = hidden_size if query_size is None else query_size

        self.key_layer = nn.Linear(key_size, hidden_size, bias=False)
        self.query_layer = nn.Linear(query_size, hidden_size, bias=False)
        self.energy_layer = nn.Linear(hidden_size, 1, bias=False)
        # self.energy_layer = nn.Linear(hidden_size, 61, bias=False)
        
        # to store attention scores
        self.alphas = None
        
    def forward(self, query=None, proj_key=None, value=None):
        # assert mask is not None, "mask is required"

        # We first project the query (the decoder state).
        # The projected keys (the encoder states) were already pre-computated.
        query = self.query_layer(query)
        # print(query.size())
        # print(proj_key.size())
        # Calculate scores.
        z = query + proj_key
        # print(z.size())
        scores = self.energy_layer(torch.tanh(query + proj_key))
        scores = scores.squeeze(2).unsqueeze(1)
        # print(scores.size())
        # print("SCORES HERE")
        # print(value.size())
        # print("VALUES HERE")
        # mask = torch.permute(mask,(0,2,1,3))
        # print(mask.size())
        # print("MASK HERE")
        # Mask out invalid positions.
        # The mask marks valid positions so we invert it using `mask & 0`.
        # scores.data.masked_fill_(mask == 0, -float('inf'))
        
        # Turn scores to probabilities.
        alphas = F.softmax(scores, dim=-1)
        self.alphas = alphas        
        # print(alphas.size())
        # print(value.size())
        # print("STUFF HERE")
        # The context vector is the weighted sum of the values.
        context = torch.bmm(alphas, value)
        
        # context shape: [B, 1, 2D], alphas shape: [B, 1, M]
        return context, alphas




def make_model(src_vocab, tgt_vocab, emb_size=256, hidden_size=512, num_layers=1, dropout=0.1):
    "Helper: Construct a model from hyperparameters."

    attention = BahdanauAttention(hidden_size).cuda()

    model = EncoderDecoder(
        Encoder(emb_size, hidden_size, num_layers=num_layers, dropout=dropout).cuda(),
        Decoder(emb_size, hidden_size, attention, num_layers=num_layers, dropout=dropout).cuda(),
        nn.Embedding(src_vocab, emb_size).cuda(),
        nn.Embedding(tgt_vocab, emb_size).cuda(),
        Generator(hidden_size, tgt_vocab).cuda())

    return model.cuda()

sess = tf.Session(config=tf.ConfigProto(log_device_placement=True))

def bone_loss(y_true, y_predict):
    loss = 0.
    # bones = [[13, 14], [14, 15], [3, 14], [4, 14], [9, 15], [10, 15],
    #               [2, 3], [1, 2], [4, 5], [5, 6], [8, 9], [7, 8], [10, 11], [11, 12]]

    bones = [[0,1],[0,2],[3,4],[3,5],[4,6],[6,8],[5,7],[7,9],[3,10],[3,11],[10,12],[11,13],[12,14],[13,15],[14,16],[15,17]]

    # mask = K.any(K.not_equal(y_true, 0.), axis=-1)  # mask is bool type with shape (?,46)
    # mask = K.cast(mask, dtype='float32')
    a,b,c = y_predict.size()
    bonelen = len(bones)
    for bone_index in range(len(bones)):
        i = bones[bone_index][0]
        j = bones[bone_index][1]

        i+=1 # i did 0 index
        j+=1 # i did 0 index
        p_bone1 = y_predict[:, :, (3 * (i - 1)):(3 * i)]
        p_bone2 = y_predict[:, :, (3 * (j - 1)):(3 * j)]
        t_bone1 = y_true[:, :, (3 * (i - 1)):(3 * i)]
        t_bone2 = y_true[:, :, (3 * (j - 1)):(3 * j)]
        # print(p_bone1.size())
        # print(p_bone2.size())
        bone_length_input = torch.sqrt(torch.sum(torch.square(p_bone2 - p_bone1), axis=-1) + 1e-10)
        # bone_length_input = K.sqrt(K.sum(K.square(p_bone2 - p_bone1), axis=-1) + 1e-10)
        # bone_length_refs = K.sqrt(K.sum(K.square(t_bone2 - t_bone1), axis=-1) + 1e-10)
        bone_length_refs = torch.sqrt(torch.sum(torch.square(t_bone2 - t_bone1), axis=-1) + 1e-10)
        
        # criterionl1 = nn.L1Loss()
        # loss = criterionl1(bone_length_input,bone_length_refs)
        
    # return loss
        # loss_a = K.abs(bone_length_refs - bone_length_input) / (bone_length_refs + 1e-10)
        loss_a = torch.square(bone_length_refs - bone_length_input)
        # print(loss_a.size())
        # loss 
        # loss_a = torch.abs(bone_length_refs - bone_length_input) / (bone_length_refs + 1e-10)
        # loss += tf.reduce_sum(loss_a, axis=-1)
        # loss += torch.sum(loss_a, axis=-1)
        loss +=torch.sum(loss_a)

    # nframes = math_ops.count_nonzero(mask, axis=1)
    # loss = loss / K.cast(nframes, dtype='float32')
    loss = loss/(a*b*bonelen)
    return loss
    # return torch.mean(loss)
    # return K.mean(loss)

def contin_loss(y_true, y_predict, gap=2, alpha=0.1):

    mask = K.any(K.not_equal(y_true, 0.), axis=-1)  # mask is bool type with shape (?,46)
    mask = K.cast(mask, dtype='float32')
    mask = K.repeat(mask, y_predict.shape[-1])
    mask = tf.transpose(mask, [0, 2, 1])

    rerange_near = tf.concat([tf.expand_dims(y_predict[:, 0, :], 1), y_predict[:, :-1, :]], 1) * mask
    rerange_far = tf.concat([y_predict[:, :gap, :], y_predict[:, :-gap, :]], 1) * mask

    shape = y_predict.get_shape().as_list()
    shape[0] = -1
    shape[2] = shape[2] / 3
    shape.append(3)
    shape = [int(i) for i in shape]
    near_gap_4dim = tf.reshape(tf.squared_difference(y_predict * mask, rerange_near), shape)
    far_gap_4dim = tf.reshape(tf.squared_difference(y_predict * mask, rerange_far), shape)
    if gap == 2:
        far_gap_4dim = tf.concat([far_gap_4dim[:, 1:, :, :], tf.expand_dims(far_gap_4dim[:, 0, :, :], 1)], 1)
    else:
        far_gap_4dim = tf.concat([far_gap_4dim[:, (gap - 1):, :, :], far_gap_4dim[:, :(gap - 1), :, :]], 1)

    # first sum: for three coordinates a,b,c; second sum: for all joints
    loss1 = tf.reduce_sum(tf.sqrt(tf.reduce_sum(near_gap_4dim, axis=-1) + 0.0000001), axis=-1)  # [173,93]
    loss2 = tf.reduce_sum(tf.sqrt(tf.reduce_sum(far_gap_4dim, axis=-1) + 0.0000001), axis=-1)  # [173,93]
    mask_alpha = mask[:, :, 0]
    mask_alpha = mask_alpha * tf.convert_to_tensor(alpha, dtype='float32')
    loss = loss1 - loss2
    loss = loss1
    loss += mask_alpha
    min_index = tf.minimum(math_ops.count_nonzero(loss1), math_ops.count_nonzero(loss2))
    loss *= math_ops.to_float(loss > 0)
    # sum: for all frames
    loss = tf.reduce_sum(loss[:, 1:(min_index + 1)], axis=-1)


    return K.mean(loss)

def L1_loss(y_true, y_predict):
    def selected_5_joints(y):
        y_5_joints = tf.concat([y[:, :, :3], y[:, :, 15:18], y[:, :, 18:21], y[:, :, 33:36], y[:, :, 42:45]], axis=-1)
        return y_5_joints
    print("HI")
    y_true_5joints = selected_5_joints(y_true)
    y_predict_5joints = selected_5_joints(y_predict)
    return tf.norm(y_predict - y_true, ord=1, keep_dims=False)#tf.norm(y_predict_5joints - y_true_5joints, ord=1, keep_dims=False)

def L2_loss(y_true, y_predict):

    shape = y_predict.get_shape().as_list()
    shape[0] = -1
    shape[2] = shape[2] / 3
    shape.append(3)
    shape = [int(i) for i in shape]
    y_true = tf.reshape(y_true, shape)
    y_predict = tf.reshape(y_predict, shape)
    ans = tf.reduce_sum(tf.sqrt(tf.reduce_sum(tf.squared_difference(y_true,y_predict),axis=-1)))# 1e-10

    return ans

def FD(y_true, y_predict): # frame distance
    ans = tf.reduce_sum(tf.squared_difference(y_true, y_predict), [1, 2])# 1e-10
    return ans


class NonMasking(Layer):
    def __init__(self, **kwargs):
        self.supports_masking = True
        super(NonMasking, self).__init__(**kwargs)

    def build(self, input_shape):
        input_shape = input_shape

    def compute_mask(self, input, input_mask=None):
        # do not pass the mask to the next layers
        return None

    def call(self, x, mask=None):
        return x

    def get_output_shape_for(self, input_shape):
        return input_shape


class RemoveRandomness(Layer):

    def __init__(self, **kwargs):
        self.supports_masking = True
        super(RemoveRandomness, self).__init__(**kwargs)

    def build(self, input_shape):
        input_shape = input_shape

    def compute_mask(self, inputs, mask):
        if isinstance(mask, list):
            mask = mask[0]
        return mask

    def call(self, inputs, mask):
        if mask is not None:
            mask = K.repeat(mask, inputs.shape[-1])
            mask = tf.transpose(mask, [0, 2, 1])
            mask = K.cast(mask, K.floatx())
        return inputs * mask

    def compute_output_shape(self, input_shape):
        return input_shape

def contin_loss(y_true, y_predict, gap=2, alpha=0.1):

    y_true_np = y_true.cpu().detach().numpy()
    # mask = K.any(K.not_equal(y_true, 0.), axis=-1)  # mask is bool type with shape (?,46)
    mask = K.any(K.not_equal(y_true_np, 0.), axis=-1)  # mask is bool type with shape (?,46)
    mask = K.cast(mask, dtype='float32')
    mask = K.repeat(mask, y_predict.shape[-1])
    mask = tf.transpose(mask, [0, 2, 1])
    # print(mask.shape)
    # print("HI")
    # print(type(mask))
    # print(y_predict[:,0,:].shape)
    # mask = list(mask)
    # print(type(mask))
    mask = mask.numpy()
    mask = torch.from_numpy(mask)
    mask = mask.cuda()
    # print(type(mask))
    # print("mask type here")
    # mask = list(mask)
    # mask = mask.numpy() 
    # mask = torch.as_tensor(mask)
    rerange_near_ = torch.concat([torch.unsqueeze(y_predict[:,0,:],1),y_predict[:,:-1,:]],1)*mask
    rerange_near = rerange_near_
    # rerange_near = tf.concat([tf.expand_dims(y_predict[:, 0, :], 1), y_predict[:, :-1, :]], 1) * mask
    # print(rerange_near_.shape)
    # print("rerange shape")
    # x1 = tf.expand_dims(y_predict[:, 0, :], 1)
    # print(x1.shape)
    # print("x1 shape")
    # x2 = tf.concat([tf.expand_dims(y_predict[:, 0, :], 1), y_predict[:, :-1, :]], 1)
    # print(x2.shape)
    # print("x2 shape")
    # print(rerange_near.shape)
    # print('rerange size')
    # x1_ = torch.unsqueeze(y_predict[:,0,:],1)
    # print("hiiis")
    # print(y_predict[:,0,:].shape)
    # print(x1_.shape)
    # print(type(x1_))
    # print("x1_ size")
    # x2_ = torch.concat([torch.unsqueeze(y_predict[:,0,:],1),y_predict[:,:-1,:]],1)
    # print(x2_.shape)
    # print(type(x2_))
    # print("x2_ size")
    rerange_far_ = torch.concat([y_predict[:,:gap,:],y_predict[:,:-gap,:]],1)*mask
    rerange_far = rerange_far_
    # print(rerange_far.shape)
    # print("rerange far shape")
    # rerange_far = tf.concat([y_predict[:, :gap, :], y_predict[:, :-gap, :]], 1) * mask
    # print(y_predict)
    # y_predict = tf.convert_to_tensor(y_predict)
    shape_ = y_predict.shape
    # print(shape_)
    # print("shape here")
    shape_ = list(shape_)
    # print(shape_)
    shape = shape_
    # shape = y_predict.get_shape().as_list()
    shape[0] = -1
    shape[2] = shape[2] / 3
    shape.append(3)
    shape = [int(i) for i in shape]
    # print(shape)
    first = torch.reshape(y_predict*mask,shape)
    second = torch.reshape(rerange_near,shape)
    third = torch.norm((first-second),dim=3)
    fourth = torch.sum(third,2)
    # print(first.shape)
    # print(second.shape)
    # print(third.shape)
    # print(fourth.shape)
    # print("first second shapes here")

    first_ = torch.reshape(y_predict*mask,shape)
    second_ = torch.reshape(rerange_far,shape)
    third_ = torch.norm((first_-second_),dim=3)
    fourth_ = torch.sum(third_,2)
    # print(first_.shape)
    # print(second_.shape)
    # print(third_.shape)
    # print(fourth_.shape)
    # print("first second shapes here")
    #fix fourth_
    loss1 = fourth
    loss2 = fourth_
    # near_gap_4dim = tf.reshape(tf.squared_difference(y_predict * mask, rerange_near), shape)
    # far_gap_4dim = tf.reshape(tf.squared_difference(y_predict * mask, rerange_far), shape)
    # if gap == 2:
        # far_gap_4dim = tf.concat([far_gap_4dim[:, 1:, :, :], tf.expand_dims(far_gap_4dim[:, 0, :, :], 1)], 1)
    # else:
    #     far_gap_4dim = tf.concat([far_gap_4dim[:, (gap - 1):, :, :], far_gap_4dim[:, :(gap - 1), :, :]], 1)

    # first sum: for three coordinates a,b,c; second sum: for all joints
    # loss1 = tf.reduce_sum(tf.sqrt(tf.reduce_sum(near_gap_4dim, axis=-1) + 0.0000001), axis=-1)  # [173,93]
    # loss2 = tf.reduce_sum(tf.sqrt(tf.reduce_sum(far_gap_4dim, axis=-1) + 0.0000001), axis=-1)  # [173,93]
    mask_alpha = mask[:, :, 0]
    # mask_alpha = mask_alpha * tf.convert_to_tensor(alpha, dtype='float32')
    mask_alpha = mask_alpha*alpha
    loss = loss1 - loss2
    loss += mask_alpha
    loss1t = loss1.cpu().detach().numpy()
    loss2t = loss2.cpu().detach().numpy()
    loss1t = tf.convert_to_tensor(loss1t)
    loss2t = tf.convert_to_tensor(loss2t)
    min_index = tf.minimum(math_ops.count_nonzero(loss1t), math_ops.count_nonzero(loss2t))
    # print(min_index)
    # print("HI")
    losst = loss.cpu().detach().numpy()
    losst = tf.convert_to_tensor(losst)
    stuff = math_ops.to_float(losst>0)
    stuff = list(stuff)
    stuff = np.array(stuff)
    # print(len(stuff))
    stuff = torch.tensor(stuff)
    stuff = stuff.cuda()
    loss *=stuff
    # print(type(loss))
    # print("Loss type here")
    # loss *= math_ops.to_float(loss > 0)
    # sum: for all frames
    # loss = tf.reduce_sum(loss[:, 1:(min_index + 1)], axis=-1)
    loss = torch.sum(loss[:, 1:(min_index + 1)], axis=-1)


    # return K.mean(loss)
    return torch.mean(loss)

def vel(inp,ground):
    a,b,c = inp.size()
    # q,w,e = ground.size()
    # print(inp.size())
    # print("over here")
    # print(ground)
    inpahead = torch.diff(inp,dim=1)
    groundahead = torch.diff(ground,dim=1)
    inpahead = inpahead[:,:-1]
    groundahead = groundahead[:,:-1]
    criterion = nn.L1Loss()
    velloss = criterion(inpahead,groundahead)
    return velloss

def chain(X):
    a,b ,c = X.size()
    # print(a,"",b,"",c)
    X = torch.reshape(X,(X.size()[0],X.size()[1],X.size()[2]//3,3))
    assert (X.size()[2]==18),'must have 18 joints'
    # chain1 = gen[0:3*3] #-18
    # chain2 = gen[4*3:7*3]
    # chain3 = gen[]# 22-18 = 4
    sidx_list = [np.asarray([0,1,2]),np.asarray([4,6,8]),np.asarray([5,7,9]),
    np.asarray([3,10,11]),np.asarray([12,14,16]),np.asarray([13,15,17])]
    # sidx_list = [np.asarray([1,3,2]),np.asarray([4,6,8]),np.asarray([5,7,9]),
    # np.asarray([3,10,11]),np.asarray([12,14,16]),np.asarray([13,15,17])]
    slic_idx =[it*X.size()[3] for it in [0,3,3,3,3,3,3]]
    slic_idx = np.cumsum(slic_idx)
    X_new = torch.zeros((X.size()[0],X.size()[1],slic_idx[-1]))
    # X_new = np.zeros((X.size()[0],X.size()[1],slic_idx[-1]))
    for idx, sidx in enumerate(sidx_list):
        X_temp = X[:, :, sidx, :]
        X_new[:, :, slic_idx[idx]:slic_idx[idx + 1]] = torch.reshape(X_temp, (
        X_temp.size()[0], X_temp.size()[1], X_temp.size()[2] * X_temp.size()[3]))
    return X_new

def chainbody(X):
    a,b ,c = X.size()
    # print(a,"",b,"",c)
    X = torch.reshape(X,(X.size()[0],X.size()[1],X.size()[2]//3,3))
    assert (X.size()[2]==18),'must have 18 joints'
    # chain1 = gen[0:3*3] #-18
    # chain2 = gen[4*3:7*3]
    # chain3 = gen[]# 22-18 = 4
    sidx_list = [np.asarray([1,0,3,4,6,8]),np.asarray([2,0,3,5,7,9]),np.asarray([0,3,10,12,14,16]),
    np.asarray([0,3,11,13,15,17]),np.asarray([8,6,4,5,7,9]),np.asarray([16,14,12,10,3,11,13,15,17]),np.asarray([8,6,4,3,10,12,16]),np.asarray([9,7,5,3,11,13,15,17]),np.asarray([8,6,4,3,11,13,15,17]),np.asarray([9,7,5,3,10,12,14,16])]
    # sidx_list = [np.asarray([1,0,3,4,6,8]),np.asarray([2,0,3,5,7,9]),np.asarray([0,3,10,12,14,16]),
    # np.asarray([0,3,11,13,15,17]),np.asarray([8,6,4,5,7,9]),np.asarray([16,14,12,10,3,11,13,15,17]),np.asarray([8,6,4,3,10,12,16]),np.asarray([9,7,5,3,11,13,15,17])]
    
    # sidx_list = [np.asarray([1,0,3,4,6,8]),np.asarray([2,0,3,5,7,9]),np.asarray([0,3,10,12,14,16]),
    # np.asarray([0,3,11,13,15,17]),np.asarray([8,6,4,5,7,9]),np.asarray([16,14,12,10,3,11,13,15,17])]
    slic_idx =[it*X.size()[3] for it in [0,6,6,6,6,6,9,7,8]]
    slic_idx = np.cumsum(slic_idx)
    X_new = torch.zeros((X.size()[0],X.size()[1],slic_idx[-1]))
    X_new = []
    # X_new = np.zeros((X.size()[0],X.size()[1],slic_idx[-1]))
    for idx, sidx in enumerate(sidx_list):
        X_temp = X[:, :, sidx, :]
        temp1=torch.reshape(X_temp, (X_temp.size()[0], X_temp.size()[1], X_temp.size()[2] * X_temp.size()[3]))
        X_new.append(temp1)
        # X_new[:, :, slic_idx[idx]:slic_idx[idx + 1]] = torch.reshape(X_temp, (
        # X_temp.size()[0], X_temp.size()[1], X_temp.size()[2] * X_temp.size()[3]))
    # print(len(X_new))
    return X_new


# def gaussIntegral(s1=None, e1=None, s2=None, e2=None):
#     A=0
#     GLI=0
#     min=-10000 
#     dot=0

#     # if(s1==None or s2==None or e1==None or e2==None):
#     #     print("Empty points")
#     #     return GLI

#     # pos = torch.randn(4,3)
#     # pos[0] = s1
#     # pos[1] = e1
#     # pos[2] = s2
#     # pos[3] = e2

#     # r13 = s2 - s1
#     # r14 = e2 - s1
#     # r23 = s2 - e1
#     # r24 = e2 - e1
#     # n = torch.randn(4,3)
#     # n[0] = torch.cross(r13,r14)
#     # n[1] = torch.cross(r14,r24)
#     # n[2] = torch.cross(r24,r23)
#     # n[3] = torch.cross(r23,r13)



#     if(s1==None or s2==None or e1==None or e2==None):
#         print("Empty points")
#         return GLI

#     pos = torch.zeros(4,3).cuda()
#     pos[0] = s1
#     pos[1] = e1
#     pos[2] = s2
#     pos[3] = e2

#     r13 = s2 - s1
#     # r13.register_hook(lambda x: x.clamp(min=-1.0, max=1.0))
#     r14 = e2 - s1
#     # r14.register_hook(lambda x: x.clamp(min=-1.0, max=1.0))
#     r23 = s2 - e1
#     # r23.register_hook(lambda x: x.clamp(min=-1.0, max=1.0))
#     r24 = e2 - e1
#     # r24.register_hook(lambda x: x.clamp(min=-1.0, max=1.0))
#     n = torch.zeros(4,3,requires_grad=True).cuda()

#     n[0] = torch.cross(r13,r14)
#     n[1] = torch.cross(r14,r24)
#     n[2] = torch.cross(r24,r23)
#     n[3] = torch.cross(r23,r13)
#     # if n.requires_grad:
#     n.register_hook(lambda x: x.clamp(min=-1.0,max=1.0))
#                 # print('n has grad')
#     # print(n)
#     # for i in range(4):
#         # for j in range(i+1,5):
#             # print(pos[i])
#             # if(torch.eq(pos[i],pos[j])):
#                 # print("same points")
#                 # return GLI
            
#     for i in range(4):
#         with torch.no_grad():
#             length = torch.norm(n[i]).clone()
#             # length.register_hook(lambda x: x.clamp(min=-1.0,max=1.0))
#         # print(length)
#         # print("norm length :"+str(i))
#         if(length!=0):
#             # print(n[i].size())
#             # n[i] = nn.functional.normalize(n[i].clone(),dim=0)
#             n[i] = n[i]/length
#             # if n[i].requires_grad:
#             n[i].register_hook(lambda x: x.clamp(min=-1.0,max=1.0))
#                 # print('n has grad')
#             # print(n[i])
#             # temp = torch.norm(n[i])
            


#     GLI=0
#     for i in range(4):
#             dot = torch.dot(n[i],n[(i+1)%4])
#             dot = torch.clip(dot,min=-1,max=1)
#             dot.register_hook(lambda x: x.clamp(min=-1.0,max=1.0))
#             dot = torch.asin(dot)
#             # if dot.requires_grad:
#             dot.register_hook(lambda x: x.clamp(min=-1.0,max=1.0))
#                 # print('dot has grad')
#             GLI+=dot
    
#     r12 = e1 - s1
#     r34 = e2 - s2
#     tmp = torch.cross(r34,r12)
#     dot = torch.dot(tmp,r13)
#     if(dot<=0):
#         GLI= -GLI
#     GLI.register_hook(lambda x: x.clamp(min=-1.0,max=1.0))
#     M_PI = 3.14
#     return GLI/(4*M_PI)


# # print(gaussIntegral(a,b,c,d))

# # size1=12
# # for i in range(0,size1,3):
# #     print(i)


# def gaussIntegralAll(path1,path2):
#     size1 = path1.size()[0]
#     size2 = path2.size()[0]
#     # print(size1)
#     # print(size2)
#     # print("SIZE HERE")
#     size1=size1-3
#     size2=size2-3
#     GLI=0

#     for i in range(0,size1,3):
#         for j in range(0,size2,3):
#             GLI+=gaussIntegral(path1[i:i+3],path1[i+3:i+6],path2[j:j+3],path2[j+3:j+6])

#     return GLI


# Calculates Gauss Integral for two line segments
def gaussIntegral(s1=None, e1=None, s2=None, e2=None):
    A=0
    GLI=0
    min=-1000
    dot=0

    if(s1==None or s2==None or e1==None or e2==None):
        print("Empty points")
        return GLI

    r13 = torch.subtract(s2,s1)
    r14 = torch.subtract(e2,s1)
    r23 = torch.subtract(s2,e1)
    r24 = torch.subtract(e2,e1)
    a, _ = s1.size()
    
    n0 = torch.cross(r13,r14,dim=-1).unsqueeze(1).cuda()
    n1 = torch.cross(r14,r24,dim=-1).unsqueeze(1).cuda()
    n2 = torch.cross(r24,r23,dim=-1).unsqueeze(1).cuda()
    n3 = torch.cross(r23,r13,dim=-1).unsqueeze(1).cuda()

    
    
    n = torch.cat([n0,n1,n2,n3],dim=1).cuda()
    if(n.requires_grad):
        n.register_hook(lambda x: x.clamp(min=-1.0,max=1.0))
    for i in range(4):
        with torch.no_grad():
            length = torch.norm(n[:,i],dim=1).clone()
            ilength = length.pow_(-1).unsqueeze(1)
            ilength = torch.cat([ilength,ilength,ilength],dim=-1)
        n[:,i]=torch.mul(n[:,i],ilength)
        if(n[:,i].requires_grad):
            n[:,i].register_hook(lambda x: x.clamp(min=-1.0,max=1.0))

    GLI = torch.zeros((a),requires_grad=True).cuda()
    for i in range(4):
        dot = torch.bmm(n[:,i].view(a,1,3),n[:,(i+1)%4].view(a,3,1))
        dot = dot.squeeze()
        dot = torch.clip(dot,min=-1,max=1)
        if(dot.requires_grad):
            dot.register_hook(lambda x: x.clamp(min=-1.0,max=1.0))
        dot = torch.asin(dot)
        if(dot.requires_grad):
            dot.register_hook(lambda x: x.clamp(min=-1.0,max=1.0))
        GLI = torch.add(GLI,dot)


    r12 = torch.sub(e1,s1)
    r34 = torch.sub(e2,s2)
    tmp = torch.cross(r34,r12)
    dot = torch.bmm(tmp.view(a,1,3),r13.view(a,3,1))
    dot = dot.squeeze()
    dot = dot.masked_fill_(dot <=0,-1)
    dot = dot.masked_fill_(dot >0, 1)
    GLI = torch.mul(GLI,dot)
    if(GLI.requires_grad):
        GLI.register_hook(lambda x: x.clamp(min=-1.0,max=1.0))
    M_PI = 3.14
    
    return GLI/(4*M_PI)

def gaussIntegralAll(path1,path2):
    size1 = path1.size()[1]
    size2 = path2.size()[1]

    size1 = size1-3
    size2 = size2-3
    GLI = torch.zeros((path1.size()[0])).cuda()
    for i in range(0,size1,3):
        for j in range(0,size2,3):
            GLI+= gaussIntegral(path1[:,i:(i+3)],path1[:,(i+3):(i+6)],path2[:,j:(j+3)],path2[:,(j+3):(j+6)])

    return GLI

class InteractionGAN():
    def __init__(self,data1,data2):

        self.dropout = 0.5
        self.num_joints = 18
        self.vector_dim = 3 * self.num_joints
        self.hidden_dim = 200
        self.hidden_dim_slice = 40
        self.num_classes = 7
        self.gap = 5 # for far frames
        self.alpha = 0.1 # for gap between far frames (3-1) and near frames (2-1) of all joints###########
        self.data_loader = data1
        self.test_data_loader = data2
        self.max_seqlength = 60
        self.action_shape = (self.max_seqlength, self.vector_dim+self.num_classes)
        self.action_shape2 = (self.max_seqlength, self.vector_dim)
        self.action_shape_double = (self.max_seqlength, 2*self.vector_dim)


    def divide_skeleton_part(self, X):
        # two arms, two legs and one trunk, index from left to right, top to bottom
        X = X.reshape(X.shape[0], X.shape[1], X.shape[2] // 3, 3)
        assert (X.shape[2] == self.num_joints), ' skeleton must has %d joints' % self.num_joints
        # l arm , r arm, l leg, r leg, trunk, head
        sidx_list = [np.asarray([9, 7, 5]), np.asarray([10, 8, 6]),
                     np.asarray([17, 15, 13]), np.asarray([18, 16, 14]), np.asarray([11, 12, 4]),np.asarray([3,2,1])]

        # sidx_list = [np.asarray([6, 5, 4]), np.asarray([7, 8, 9]),
                    #  np.asarray([12, 11, 10]), np.asarray([13, 14, 15]), np.asarray([1, 2, 3])]

        slic_idx = [it * X.shape[3] for it in [0, 3, 3, 3, 3, 3,3]]
        slic_idx = np.cumsum(slic_idx)

        X_new = np.zeros((X.shape[0], X.shape[1], slic_idx[-1]))
        for idx, sidx in enumerate(sidx_list):
            sidx = sidx - 1  # index starts from 0
            X_temp = X[:, :, sidx, :]
            X_new[:, :, slic_idx[idx]:slic_idx[idx + 1]] = np.reshape(X_temp, (
            X_temp.shape[0], X_temp.shape[1], X_temp.shape[2] * X_temp.shape[3]))
        return X_new

    def restore_skeleton_part(self, X):
        # two arms, two legs and one trunk, index from left to right, top to bottom
        X = X.reshape(X.shape[0], X.shape[1], X.shape[2] // 3, 3)
        assert (X.shape[2] == self.num_joints), ' skeleton must has %d joints' % self.num_joints
        sidx_list = [np.asarray([13, 14, 15]), np.asarray([3, 2, 1]),
                     np.asarray([4, 5, 6]), np.asarray([9, 8, 7]), np.asarray([10, 11, 12])]

        slic_idx = [it * X.shape[3] for it in [0, 3, 3, 3, 3, 3]]
        slic_idx = np.cumsum(slic_idx)

        X_new = np.zeros((X.shape[0], X.shape[1], slic_idx[-1]))
        for idx, sidx in enumerate(sidx_list):
            sidx = sidx - 1  # index starts from 0
            X_temp = X[:, :, sidx, :]
            X_new[:, :, slic_idx[idx]:slic_idx[idx + 1]] = np.reshape(X_temp, (
            X_temp.shape[0], X_temp.shape[1], X_temp.shape[2] * X_temp.shape[3]))
        return X_new


    def build_generator(self):
        encoder_inputs_A = Input(shape=self.action_shape)
    
        new_slic_idx = [it*3 for it in [0, 3, 3, 3, 3, 3,3]]
        new_slic_idx.append(7)

        new_slic_idx = np.cumsum(new_slic_idx)
        hierLSTM = []
        hierLSTM_out = []
        hierState_h = []
        hierState_c = []
        dummyLSTM = []

        def slice(x, index1, index2):
            return x[:, :, index1:index2]
        for slc_id in range(0, len(new_slic_idx) - 1):
    
            length = len(new_slic_idx)
            sliced_data = Lambda(slice, arguments={'index1': new_slic_idx[slc_id], 'index2':new_slic_idx[slc_id+1]})(encoder_inputs_A)
            sliced_data = Masking(mask_value=0.)(sliced_data)
            # print(sliced_data.shape)
            shape = (sliced_data.shape)[2]
            shape = int(shape)
            sliced_data = Dense(shape+50)(sliced_data)
            slice_LSTM, state_h, state_c = LSTM(self.hidden_dim_slice, return_sequences=True, return_state=True)(sliced_data)
            hierLSTM.append(slice_LSTM)
            hierState_h.append(state_h)
            hierState_c.append(state_c)

        def generate_y0(x):
            y0 = K.zeros_like(x)  # (samples, timesteps, input_dims)
            y0 = K.sum(y0, axis=(1, 2))  # (samples, )
            y0 = K.expand_dims(y0)  # (samples, 1)
            # y0 = K.tile(y0, [1, 240*2])#1024])
            y0 = K.tile(y0, [1, 280])#1024])
            return y0

        hierLSTM_out = concatenate(hierLSTM, axis=-1)
        self.store = hierLSTM_out
        state_y = Lambda(generate_y0)(hierLSTM_out)
        hierState_h_out = concatenate(hierState_h, axis=-1)
        hierState_c_out = concatenate(hierState_c, axis=-1)
        decoder_initial = [state_y, hierState_h_out, hierState_c_out]

        aLSTM_out = AttentionDecoder(6*self.hidden_dim_slice+(40), self.hidden_dim+(40)+(40), return_sequences=True)(hierLSTM_out, initial_state=decoder_initial)
        inter_outputs1 = TimeDistributed(Dense(self.vector_dim))(aLSTM_out)
        inter_outputs2 = RemoveRandomness()(inter_outputs1)
        decoder_outputs = NonMasking()(inter_outputs2)
        return Model(encoder_inputs_A, [decoder_outputs,hierLSTM_out])

    def build_discriminator(self):

        action_B = Input(shape=self.action_shape2)   
        self.modelD = Sequential()
        self.modelD.add(NonMasking(input_shape=self.action_shape2))
        self.modelD.add(Masking(mask_value=0., input_shape=self.action_shape2))
        self.modelD.add(Bidirectional(LSTM(self.hidden_dim, return_sequences=True, kernel_constraint=unit_norm())))
        self.modelD.add(Bidirectional(LSTM(self.hidden_dim, return_sequences=True, kernel_constraint=unit_norm())))
        #self.modelD.add(Dropout(0.5))
        #self.modelD.add(BatchNormalization(momentum=0.8))
        self.modelD.add(NonMasking())
        self.modelD.add(Flatten())

        self.modelD.summary()

        features = self.modelD(action_B)
        valid = Dense(1, activation="sigmoid")(features)
        label = Dense(self.num_classes + 1, activation="softmax", kernel_constraint=unit_norm())(features)########################
        print("HELLOD")
        return Model(action_B, [valid, label])
    
    def build_classifier_A(self):
        action_B = Input(shape=self.action_shape2)   
        self.modelDd = Sequential()
        self.modelDd.add(NonMasking(input_shape=self.action_shape2))
        self.modelDd.add(Masking(mask_value=0., input_shape=self.action_shape2))
        self.modelDd.add(Bidirectional(LSTM(self.hidden_dim, return_sequences=True, kernel_constraint=unit_norm())))
        self.modelDd.add(Bidirectional(LSTM(self.hidden_dim, return_sequences=True, kernel_constraint=unit_norm())))
        #self.modelD.add(Dropout(0.5))
        #self.modelD.add(BatchNormalization(momentum=0.8))
        self.modelDd.add(NonMasking())
        self.modelDd.add(Flatten())

        self.modelDd.summary()

        features = self.modelDd(action_B)
        # valid = Dense(1, activation="sigmoid")(features)
        label = Dense(self.num_classes , activation="softmax", kernel_constraint=unit_norm())(features)########################
        print("HELLOD")
        return Model(action_B, [label])
    
    def build_classifier_B(self):
        action_B = Input(shape=self.action_shape2)   
        self.modelDdd = Sequential()
        self.modelDdd.add(NonMasking(input_shape=self.action_shape2))
        self.modelDdd.add(Masking(mask_value=0., input_shape=self.action_shape2))
        self.modelDdd.add(Bidirectional(LSTM(self.hidden_dim, return_sequences=True, kernel_constraint=unit_norm())))
        self.modelDdd.add(Bidirectional(LSTM(self.hidden_dim, return_sequences=True, kernel_constraint=unit_norm())))
        #self.modelD.add(Dropout(0.5))
        #self.modelD.add(BatchNormalization(momentum=0.8))
        self.modelDdd.add(NonMasking())
        self.modelDdd.add(Flatten())

        self.modelDdd.summary()

        features = self.modelDdd(action_B)
        # valid = Dense(1, activation="sigmoid")(features)
        label = Dense(self.num_classes , activation="softmax", kernel_constraint=unit_norm())(features)########################
        print("HELLOD")
        return Model(action_B, [label])


    def train(self, epochs, batch_size):

        self.test_fd = []
        
        half_batch = batch_size // 2
        criterion = nn.MSELoss()
        
        V = 18*3
        #TopoFormer is created here
        model_trans = make_modeltrans(V, V, N=6).cuda()
        model_trans.load_state_dict(torch.load("./modeltransformermlpintra50")) # modeltransformermlpintra 
        model_opt = torch.optim.Adam(model_trans.parameters(),lr=0.0001)

        # if USE_CUDA:
            # model.cuda()
        # model.cuda()
        # model.train()
        cw1 = {0.9: 1, 0.1: 1} #cw1 = {0.1: 1, 0.9: 1}
        cw2 = {i: 0.375 for i in range(self.num_classes)}
        cw2[self.num_classes] = 1.0 / half_batch
        # Adversarial ground truths
        valid = np.ones((batch_size, 1))*0.9 #####
        fake = np.zeros((batch_size, 1))+0.1 #####

        AFD = np.zeros(self.num_classes)
        AFD_max = np.full(self.num_classes, np.inf)
        bestg = [1000 for i in range(self.num_classes)]
        skip=0.0


        flag=0
        batch_i=0
        model_trans.eval()
        maxx=maxy=maxz=minx=minz=miny=0
        for epoch in range(0,epochs):
            for i, (data_) in enumerate(self.data_loader): # in_n + kz
                # continue
               
                batch_i+=1
                
                batch_size, seq_len, _ = data_.shape
                
                A_trains = data_[:,:,:18*3]
                # print(A_trains.size())
                B_trains = data_[:,:,18*3:108].cuda()
                # B_trains = tf.convert_to_tensor(data_[:,:,18*3:108].cpu().numpy())
                y_train = data_[:,0,108].cpu().numpy()
               

                ycat = to_categorical(y_train, num_classes=self.num_classes)
                ydtrain = np.array(y_train)

          
                A_traind = A_trains.tolist()
                
                ycatd = ycat.tolist()
               
                for i in range(len(A_trains)):
                    ycatdz = to_categorical(ydtrain[i], num_classes=self.num_classes)                    
                    for j in range(len(A_trains[i])):
                        for x in ycatdz:
                            A_traind[i][j].append(x)
                # append ytrain to A_trains
                A_traind = np.array(A_traind)
                A_traind = torch.from_numpy(A_traind).cuda()
                A_traind = A_traind.float()
              
                a,b,c = data_.shape
                # print(data_.shape,"DATA SHAPE")
                src = torch.randn(a,b)
                #         src = src[:,:,0]
                pad = 0
                src_mask = (src != pad).unsqueeze(-2).cuda()
              
                dtrg = src
                dtrg_y = src[:,1:]
           
                def make_std_mask(tgt, pad):
                    "Create a mask to hide padding and future words."
                    tgt_mask = (tgt != pad).unsqueeze(-2)
            #         tgt_mask = (tgt != pad).unsqueeze(-3)
                    tgt_mask = tgt_mask & Variable(
                        subsequent_mask(tgt.size(-1)).type_as(tgt_mask.data))
                    return tgt_mask
                
                trg_mask = make_std_mask(dtrg, pad).cuda()
                ntokens = (dtrg_y != pad).data.sum()
             
                q,w,e = B_trains.shape
               
                
                Bpad = torch.ones(q,w+1,e).cuda()
                Bpad[:,1:] = B_trains
                Bpad = Bpad[:,:-1]
                a,b,c = data_.shape
                
                time1 = time.time()
             
                counter =0 
                chainground = chain(B_trains)
                chainA = chain(data_[:,:,:18*3])
                a,b,c = B_trains.size()
               

                chainground = torch.reshape(chainground,(a*b,6,3*3)).cuda() 
                chainA = torch.reshape(chainA,(a*b,6,3*3)).cuda()
                a,b,c = B_trains.size()

                GLIground = torch.empty((a*b,15),requires_grad=False).cuda()
                JJground = torch.ones((a*b,15),requires_grad=False).cuda()*100000
               
                q,w,e = B_trains.shape
                pad=0

             
                
                counter =0
                for q in range(6):
                    for w in range(q+1,6):
                        gli = gaussIntegralAll(chainA[:,q],chainA[:,w])
                        GLIground[:,counter]=gli
                        counter +=1
                

                counter = 0
                for counter in range(15):
                    for q in range(6):
                        for w in range(q+1,6):
                            for i in range(3):
                                for j in range(3):
                                    temp = chainA[:,q,(i)*3:(i+1)*3]-chainA[:,w,(j)*3:(j+1)*3]
                    
                                    temp = torch.norm(temp,p=2,dim=1)
                                
                                    JJground[:,counter] = torch.min(JJground[:,counter],temp)
                
       
                alpha = 0.001
                beta = 90
                gamma = 16000
           
                JJground = piecewise_index(JJground,alpha,beta,gamma,torch.float64)
           
                relenc = torch.zeros(a*b,15*30)
                for i in range(15):
                    ycatdz = to_categorical(JJground[:,i].cpu(), num_classes=30)         
                
                    ycatdz = torch.Tensor(ycatdz).cuda()
                    if(i==0):
                        relenc = ycatdz
                    else:
                        relenc = torch.cat([relenc,ycatdz],axis=-1)
                
                relenc = relenc.reshape(a,b,15*30)

                GLIground =  GLIground.reshape(a,b,15)
           
                A_traind = torch.cat([A_traind,GLIground],axis=-1)
               
                q,w,e = data_.shape
                global flagenc
                flagenc = 0
                for i in range(100):
                  
                    Bpad = torch.ones(q,i+1,18*3).cuda()
                
                    dtrg = src[:,:i+1]
                
                    trg_mask = make_std_mask(dtrg, pad).cuda()
                   
                    if(i>0):
                        Bpad[:,1:] = out
               
                    out = model_trans.forward(A_traind,relenc,Bpad,src_mask,trg_mask)

              
                dataout_ = B_trains
                loss = criterion(out,dataout_)
                loss1 = loss
               
                time1 = time.time()

                
                min = 9999
                max = -9999
              
                time2 = time.time()
                print("Time2",time2-time1)
              
                
                print("loss value",loss.item(),"epoch",epoch)
                
                model_opt.zero_grad()
                loss.backward()
                model_opt.step()
                continue
            batch_i_test =0
            n=0

            
            # if(epoch%3==0):
            #     torch.save(model_trans.state_dict(),"./modeltransformermlpintra"+str(epoch))
            if(epoch%20==0):
                # continue
                out_n = 50
                out_n = 100
                genpen = np.zeros((1,500))
                groundpen = np.zeros((1,500))
                mpjpe_joi, mpjpe_ali = np.zeros([out_n]),np.zeros([out_n])
                interpennum = np.zeros((2240))
                interpentotal = 0
                model_trans.eval()
                transencstack = 0
                transactstack =0
                n = 0   
                # model_trans.train()
                flagact = 0
                firstflag = 0
                for i, (data_) in enumerate(self.test_data_loader):
                    print("TEST")

                    Minv = data_[:,:,18*3*2:(18*3*2+6*3)]
                    Minv = Minv[:,:,:-2]
                    data1 = data_[:,:,:18*3*2]
                    data2 = data_[:,:,-1].unsqueeze(dim=2)
                    data_ = torch.concat([data1,data2],dim=2)
                    dataout_ = data_
                    # data_ = data_[:,:50]
                    A_trains = data_[:,:,:18*3]
                    batch_size,b,c = A_trains.size()
                    n += batch_size
                    act = data_[:,0,-1]
                    actsingle = act[0]


                    dataout_ = data_
                    A_trains = data_[:,:,:18*3]
                    batch_size,b,c = A_trains.size()
                    n += batch_size
                    act = data_[:,0,-1]
                    actsingle = act[0]

                    
        
                    # if(act!=5):
                    #     continue
         
                    B_trains = data_[:,:,18*3:108].cuda()
              
                    y_train = data_[:,0,108].cpu().numpy()
                    batch_i_test+=1

                    ycat = to_categorical(y_train, num_classes=self.num_classes)
                    ydtrain = np.array(y_train)

        
                    A_traind = A_trains.tolist()
                
                    ycatd = ycat.tolist()
        
                    for i in range(len(A_trains)):
                        ycatdz = to_categorical(ydtrain[i], num_classes=self.num_classes)
                        for j in range(len(A_trains[i])):
                            for x in ycatdz:
                                A_traind[i][j].append(x)
                    # append ytrain to A_trains
                    A_traind = np.array(A_traind)
                    A_traind = torch.from_numpy(A_traind).cuda()
                    A_traind = A_traind.float()
        

                    a,b,c = data_.shape
                    src = torch.randn(a,b)
                    pad = 0
                    src_mask = (src != pad).unsqueeze(-2).cuda()

                    dtrg = src
                    dtrg_y = src[:,1:]

                    def make_std_mask(tgt, pad):
                        "Create a mask to hide padding and future words."
                        tgt_mask = (tgt != pad).unsqueeze(-2)
                        tgt_mask = tgt_mask & Variable(
                            subsequent_mask(tgt.size(-1)).type_as(tgt_mask.data))
                        return tgt_mask
                
                    trg_mask = make_std_mask(dtrg, pad).cuda()
                    ntokens = (dtrg_y != pad).data.sum()
                    a,b,c = data_.shape
                    chainground = chain(B_trains)
                    chainA = chain(data_[:,:,:18*3])
                    a,b,c = B_trains.size()

                    chainground = torch.reshape(chainground,(a*b,6,3*3)).cuda() 
                    chainA = torch.reshape(chainA,(a*b,6,3*3)).cuda()
                    a,b,c = B_trains.size()
                    GLIground = torch.empty((a*b,15),requires_grad=False).cuda()
                    JJground = torch.ones((a*b,15),requires_grad=False).cuda()*100000

                    q,w,e = B_trains.shape

                    pad=0

                    counter =0
                    for q in range(6):
                        for w in range(q+1,6):

                            gli = gaussIntegralAll(chainA[:,q],chainA[:,w])
                            GLIground[:,counter]=gli
                            counter +=1

                    counter = 0
                    for counter in range(15):
                        for q in range(6):
                            for w in range(q+1,6):
                                for i in range(3):
                                    for j in range(3):
                                        temp = chainA[:,q,(i)*3:(i+1)*3]-chainA[:,w,(j)*3:(j+1)*3]
                                        temp = torch.norm(temp,p=2,dim=1)
                                        JJground[:,counter] = torch.min(JJground[:,counter],temp)
                    
            
                    alpha = 0.001
                    beta = 90
                    gamma = 16000
                    
               
                    JJground = piecewise_index(JJground,alpha,beta,gamma,torch.float64)
    

                    relenc = torch.zeros(a*b,15*30)
                    for i in range(15):
                        ycatdz = to_categorical(JJground[:,i].cpu(), num_classes=30)         
                        ycatdz = torch.Tensor(ycatdz).cuda()
                        if(i==0):
                            relenc = ycatdz
                        else:
                            relenc = torch.cat([relenc,ycatdz],axis=-1)
                    
                    relenc = relenc.reshape(a,b,15*30)
                    GLIground =  GLIground.reshape(a,b,15)
     
                    A_traind = torch.cat([A_traind,GLIground],axis=-1)

                    
                    q,w,e = B_trains.shape
                    for i in range(100):
                        
                        Bpad = torch.ones(q,i+1,18*3).cuda()
        
                        dtrg = src[:,:i+1]

                        trg_mask = make_std_mask(dtrg, pad).cuda()

                        if(i>0):
                            Bpad[:,1:] = out

                        out = model_trans.forward(A_traind,relenc,Bpad,src_mask,trg_mask)
                    
                    pre_output = out

                    #calc gli here for interpen
                    a,b,c = dataout_.shape
                    chainground = chain(data_[:,:,18*3:18*3*2])
                    chaingenB = chain(pre_output)
                    chaingenA = chain(data_[:,:,:18*3])
                    chainA = chain(data_[:,:,:18*3])
                    # a,b,c = B_trains.size()
                    a,b,c = dataout_.shape

                    chainground = torch.reshape(chainground,(a*b,6,3*3)).cuda()
                    chaingenA = torch.reshape(chaingenA,(a*b,6,3*3)).cuda()
                    chaingenB = torch.reshape(chaingenB,(a*b,6,3*3)).cuda()
                    chainA = torch.reshape(chainA,(a*b,6,3*3)).cuda()
                    a,b,c = dataout_.shape

                    GLIgen = torch.empty((a*b,15+15+36),requires_grad=True).cuda()
                    GLIground = torch.empty((a*b,15+15+36)).cuda()
                    time1 = time.time()

                    min = 9999
                    max = -9999
                    
                    counter =0 
                    for q in range(6):
                        for w in range(q+1,6):
                            gli = gaussIntegralAll(chaingenA[:,q],chaingenA[:,w])
                            with torch.no_grad():
                                GLIgen[:,counter]=gli
                            counter +=1
            
                    counter =0 
                    for q in range(6):
                        for w in range(q+1,6):
                            gli = gaussIntegralAll(chainA[:,q],chainA[:,w])
                            GLIground[:,counter]=gli
                            counter +=1

                    counter =15 
                    for q in range(6):
                        for w in range(q+1,6):
                            gli = gaussIntegralAll(chaingenB[:,q],chaingenB[:,w])
                            with torch.no_grad():
                                GLIgen[:,counter]=gli
                            counter +=1
            
                    counter =15 
                    for q in range(6):
                        for w in range(q+1,6):
                            gli = gaussIntegralAll(chainground[:,q],chainground[:,w])
                            GLIground[:,counter]=gli
                            counter +=1

                    counter = 30
                    for q in range(6):
                        for w in range(6):
                            gli = gaussIntegralAll(chaingenB[:,q],chaingenA[:,w])
                            with torch.no_grad():
                                GLIgen[:,counter]=gli
                            counter +=1
                    counter = 30
                    for q in range(6):
                        for w in range(6):
                            gli = gaussIntegralAll(chainground[:,q],chainA[:,w])
                            GLIground[:,counter]=gli
                            counter +=1

                    a,b,c = dataout_.shape

                    GLIgen = GLIgen.reshape((a,b,15+15+36))
                    GLIground = GLIground.reshape((a,b,15+15+36))

                    GLIgenpen = torch.abs(torch.diff(GLIgen,dim=1))
                    GLIgroundpen = torch.abs(torch.diff(GLIground,dim=1))
                    GLIgenpen = GLIgenpen[:,:-1]
                    GLIgroundpen = GLIgroundpen[:,:-1]
                    interpen = 0
                    a,b,c = GLIgenpen.size()
                    for i in range(a):
                        for j in range(b):
                            for k in range(c):
                                pen = 0
                                if(GLIgenpen[i][j][k]>0.5 and GLIgroundpen[i][j][k]<0.5):
                                    batchnum = n - batch_size + i 
                                    print(n)
                                    print("batch number",batchnum)
                                    print("i number",i)
                                    print("frame number",j)
                                    interpen +=1
                                    interpennum[(n-batch_size)+i] +=1
                                    interpentotal += 1
                    print(torch.max(GLIgenpen),"GLIgenpen max",torch.min(GLIgenpen),"Gligenpen min")
                    print(torch.max(GLIgroundpen),"GLIgroundpen max",torch.min(GLIgroundpen),"Gligroundpen min")
                    print("Number of interpen",interpen)
                    print("Number of interpen total",interpentotal)

                    maxx = 1718.3108
                    maxy = 2041.6564
                    maxz = 1670.1266
                    minx = -1703.2695
                    miny = -2060.1829
                    minz = -1194.0321

                    gt = data_[:,:,:-1].cuda()
                    pre_output = torch.cat([A_trains.cuda(),pre_output],axis=-1).cuda()
                    pred = pre_output
                    a,b,c = gt.shape
                    gt = gt.reshape(a,b,c//3,3)
                    pred = pred.reshape(a,b,c//3,3)
                    print(n)    
                    tmp_joi = torch.sum(torch.mean(torch.norm(gt - pred, dim=3), dim=2), dim=0)
                    mpjpe_joi += tmp_joi.cpu().data.numpy()
                    
                    pred_ali = pred
                    gt_ali = gt
                    pred_ali = pred #torch.cat((pred[:,:,int(nb_kpts/2):], data_utils.unnorm_abs2Indep(pred[:,:,:int(nb_kpts/2)])), axis=2)
                    gt_ali = gt #torch.cat((gt[:,:,int(nb_kpts/2):], data_utils.unnorm_abs2Indep(gt[:,:,:int(nb_kpts/2)])), axis=2)
                    nb_kpts = 18*2
                    pred_ali_l = rigid_align_torch(pred_ali[:,:,:int(nb_kpts/2)], gt_ali[:,:,:int(nb_kpts/2)])
                    pred_ali_f = rigid_align_torch(pred_ali[:,:,int(nb_kpts/2):], gt_ali[:,:,int(nb_kpts/2):])
                    pred_ali = torch.cat((pred_ali_l,pred_ali_f), axis=2)

                    tmp_ali = torch.sum(torch.mean(torch.norm(gt_ali - pred_ali, dim=3), dim=2), dim=0)
                    mpjpe_ali += tmp_ali.cpu().data.numpy()



                    A_ = data_[:,:,:18*3].cpu().detach().numpy()
                    B_ = data_[:,:,18*3:108].cpu().detach().numpy()

                    a,b,c = A_.shape
          
                    ground = np.concatenate((A_,B_),axis=-1)
                    gen = pre_output.cpu().detach().numpy()

                    
                    ground = np.reshape(ground,(a,b,18*2,3))
                    gen = np.reshape(gen,(a,b,18*2,3))

    
                    data_ = torch.from_numpy(ground)
                    pred = torch.from_numpy(gen)


                    pat2 = "./outputs/examplegli"+str(n)+".mp4"
                    pat = "ground"+str(n)+".txt"
                    pat0 = "gli"+str(n)+".txt"
    
                    np.save("transmlpproto2ground"+str(act),ground[0])
                    np.save("transmlpproto2gen"+str(act),gen[0])

                    #Remove min-max normalization of output

                    gen[:,:,:,0] = ( gen[:,:,:,0]*(maxx-minx) + minx )
                    ground[:,:,:,0] = ( ground[:,:,:,0]*(maxx-minx) + minx )
                    gen[:,:,:,1] = ( gen[:,:,:,1]*(maxy-miny) + miny )
                    ground[:,:,:,1] = ( ground[:,:,:,1]*(maxy-miny) + miny )

                    gen[:,:,:,2] = ( gen[:,:,:,2]*(maxz-minz) + minz )
                    ground[:,:,:,2] = (ground[:,:,:,2]*(maxz-minz) + minz )

                    genscale = gen
                    groundscale = ground


                    for i in range(1):
                        vis_2p.vis_pi_compare(ground[0],
                            gen[0],pat2,pat0,pat)
                    continue
                np.save("transencstack",transencstack)
                np.save("transactstack",transactstack)
                np.save("gliinterpennum",interpennum)   
                print(n,"N VALUE")
                print(mpjpe_joi,"MPJPE JOI")
                print(mpjpe_ali,"MPJPE_ALI")
                mpjpe_joi, mpjpe_ali = mpjpe_joi/n, mpjpe_ali/n  # n = testing dataset length
                np.save("baseglifirst",interpennum)
                groundpen = groundpen[1:]
                genpen = genpen[1:]

                out_print_frame = [4,9,14,19,24,27,31,34,37,41,46,49,54,59,64,69,74,79,84,89,94,99]
                res_dic = {"mpjpe_joi": mpjpe_joi[out_print_frame],
                   "mpjpe_ali": mpjpe_ali[out_print_frame]}
                print('Error at each output frame:\n Frame number:{}\n Error:{}'.format(out_print_frame,res_dic))
                exit()
            



### SCA code ends here
# tf.compat.v1.disable_v2_behavior()

def contin_loss(y_true, y_predict, gap=2, alpha=0.1):
    y_true_np = np.asarray(y_true)
    # y_true_np = y_true.cpu().detach().numpy()
    # mask = K.any(K.not_equal(y_true, 0.), axis=-1)  # mask is bool type with shape (?,46)
    mask = K.any(K.not_equal(y_true_np, 0.), axis=-1)  # mask is bool type with shape (?,46)
    mask = K.cast(mask, dtype='float32')
    mask = K.repeat(mask, y_predict.shape[-1])
    mask = tf.transpose(mask, [0, 2, 1])
    # print(mask.shape)
    # print("HI")
    # print(type(mask))
    # print(y_predict[:,0,:].shape)
    # mask = list(mask)
    # print(type(mask))
    # mask = mask.cpu().numpy()
    mask = mask.numpy()
    # mask = np.asarray(mask)
    mask = torch.from_numpy(mask)
    mask = mask.cuda()
    # print(type(mask))
    # print("mask type here")
    # mask = list(mask)
    # mask = mask.numpy() 
    # mask = torch.as_tensor(mask)
    rerange_near_ = torch.concat([torch.unsqueeze(y_predict[:,0,:],1),y_predict[:,:-1,:]],1)*mask
    rerange_near = rerange_near_
    # rerange_near = tf.concat([tf.expand_dims(y_predict[:, 0, :], 1), y_predict[:, :-1, :]], 1) * mask
    # print(rerange_near_.shape)
    # print("rerange shape")
    # x1 = tf.expand_dims(y_predict[:, 0, :], 1)
    # print(x1.shape)
    # print("x1 shape")
    # x2 = tf.concat([tf.expand_dims(y_predict[:, 0, :], 1), y_predict[:, :-1, :]], 1)
    # print(x2.shape)
    # print("x2 shape")
    # print(rerange_near.shape)
    # print('rerange size')
    # x1_ = torch.unsqueeze(y_predict[:,0,:],1)
    # print("hiiis")
    # print(y_predict[:,0,:].shape)
    # print(x1_.shape)
    # print(type(x1_))
    # print("x1_ size")
    # x2_ = torch.concat([torch.unsqueeze(y_predict[:,0,:],1),y_predict[:,:-1,:]],1)
    # print(x2_.shape)
    # print(type(x2_))
    # print("x2_ size")
    rerange_far_ = torch.concat([y_predict[:,:gap,:],y_predict[:,:-gap,:]],1)*mask
    rerange_far = rerange_far_
    # print(rerange_far.shape)
    # print("rerange far shape")
    # rerange_far = tf.concat([y_predict[:, :gap, :], y_predict[:, :-gap, :]], 1) * mask
    # print(y_predict)
    # y_predict = tf.convert_to_tensor(y_predict)
    shape_ = y_predict.shape
    # print(shape_)
    # print("shape here")
    shape_ = list(shape_)
    # print(shape_)
    shape = shape_
    # shape = y_predict.get_shape().as_list()
    shape[0] = -1
    shape[2] = shape[2] / 3
    shape.append(3)
    shape = [int(i) for i in shape]
    # print(shape)
    first = torch.reshape(y_predict*mask,shape)
    second = torch.reshape(rerange_near,shape)
    third = torch.norm((first-second),dim=3)
    fourth = torch.sum(third,2)
    # print(first.shape)
    # print(second.shape)
    # print(third.shape)
    # print(fourth.shape)
    # print("first second shapes here")

    first_ = torch.reshape(y_predict*mask,shape)
    second_ = torch.reshape(rerange_far,shape)
    third_ = torch.norm((first_-second_),dim=3)
    fourth_ = torch.sum(third_,2)
    # print(first_.shape)
    # print(second_.shape)
    # print(third_.shape)
    # print(fourth_.shape)
    # print("first second shapes here")
    #fix fourth_
    loss1 = fourth
    loss2 = fourth_
    # near_gap_4dim = tf.reshape(tf.squared_difference(y_predict * mask, rerange_near), shape)
    # far_gap_4dim = tf.reshape(tf.squared_difference(y_predict * mask, rerange_far), shape)
    # if gap == 2:
        # far_gap_4dim = tf.concat([far_gap_4dim[:, 1:, :, :], tf.expand_dims(far_gap_4dim[:, 0, :, :], 1)], 1)
    # else:
    #     far_gap_4dim = tf.concat([far_gap_4dim[:, (gap - 1):, :, :], far_gap_4dim[:, :(gap - 1), :, :]], 1)

    # first sum: for three coordinates a,b,c; second sum: for all joints
    # loss1 = tf.reduce_sum(tf.sqrt(tf.reduce_sum(near_gap_4dim, axis=-1) + 0.0000001), axis=-1)  # [173,93]
    # loss2 = tf.reduce_sum(tf.sqrt(tf.reduce_sum(far_gap_4dim, axis=-1) + 0.0000001), axis=-1)  # [173,93]
    mask_alpha = mask[:, :, 0]
    # mask_alpha = mask_alpha * tf.convert_to_tensor(alpha, dtype='float32')
    mask_alpha = mask_alpha*alpha
    loss = loss1 - loss2
    loss += mask_alpha
    loss1t = loss1.cpu().detach().numpy()
    loss2t = loss2.cpu().detach().numpy()
    loss1t = tf.convert_to_tensor(loss1t)
    loss2t = tf.convert_to_tensor(loss2t)
    min_index = tf.minimum(math_ops.count_nonzero(loss1t), math_ops.count_nonzero(loss2t))
    # print(min_index)
    # print("HI")
    losst = loss.cpu().detach().numpy()
    losst = tf.convert_to_tensor(losst)
    stuff = math_ops.to_float(losst>0)
    stuff = list(stuff)
    stuff = np.array(stuff)
    # print(len(stuff))
    stuff = torch.tensor(stuff)
    stuff = stuff.cuda()
    loss *=stuff
    # print(type(loss))
    # print("Loss type here")
    # loss *= math_ops.to_float(loss > 0)
    # sum: for all frames
    # loss = tf.reduce_sum(loss[:, 1:(min_index + 1)], axis=-1)
    loss = torch.sum(loss[:, 1:(min_index + 1)], axis=-1)


    # return K.mean(loss)
    return torch.mean(loss)

def main(opt):
    torch.manual_seed(1234567890)
    print('>>> DATA loading >>>')



    #over here

    dataset = datasets.Datasets(opt, is_train=True)
    in_features = dataset.in_features
    print('>>> Training dataset length: {:d}'.format(dataset.__len__()))
 
    opt.batch_size = 6
    data_loader1 = DataLoader(dataset, batch_size=opt.batch_size, shuffle=True, num_workers=0, pin_memory=True)
    dataset = datasets.Datasets(opt, is_train=False)
    print('>>> Test dataset length: {:d}'.format(dataset.__len__()))
    opt.test_batch_size = 1
    data_loader2 = DataLoader(dataset, batch_size=opt.test_batch_size, shuffle=False, num_workers=0, pin_memory=True)
    gan = InteractionGAN(data_loader1,data_loader2)
    gan.train(epochs=4000, batch_size=32)
    
    in_features = 54*2
    # print(in_features)
    nb_kpts = int(in_features/3)

    ## model
    print('>>> MODEL >>>')
    net_pred = AttModel.AttModel(in_features=in_features, kernel_size=opt.kernel_size, d_model=opt.d_model,
                                 num_stage=opt.num_stage, dct_n=opt.dct_n, input_n=opt.input_n)
    net_pred.cuda()
    
    net_guid = Classif.GuidClass()
    net_guid.cuda()

    lr_now = opt.lr_now
    start_epoch = 1
    print(">>> total params: {:.2f}M".format(sum(p.numel() for p in net_pred.parameters()) / 1000000.0))
    print(">>> is_load:{}, is_eval:{}, ckpt:{}".format(opt.is_load, opt.is_eval,  opt.ckpt))
    if opt.is_load or opt.is_eval:
        if '.pth.tar' in opt.ckpt:
            model_path_len = opt.ckpt
        elif opt.test_epo is not None:
            model_path_len = '{}/ckpt_epo{}.pth.tar'.format(opt.ckpt, opt.test_epo)
        else:
            model_path_len = './{}/ckpt_last.pth.tar'.format(opt.ckpt)
        print(">>> loading ckpt from '{}'".format(model_path_len))
        ckpt = torch.load(model_path_len)
        start_epoch = ckpt['epoch'] + 1
        lr_now = ckpt['lr']
        net_pred.load_state_dict(ckpt['state_dict'])
        print(">>> ckpt loaded (epoch: {} | err: {} | lr: {})".format(ckpt['epoch'], ckpt['err'], lr_now))

    ## train or test
    if not opt.is_eval: #train
        optimizer = optim.Adam(filter(lambda x: x.requires_grad, net_pred.parameters()), lr=opt.lr_now)

        optimizer2 = optim.Adam(filter(lambda x: x.requires_grad, net_guid.parameters()), lr=opt.lr_now)
        
        if opt.is_load:
            optimizer.load_state_dict(ckpt['optimizer'])
        util.save_ckpt({'epoch': 0, 'lr': lr_now, 'err': 0, 'state_dict': net_pred.state_dict(), 'optimizer': optimizer.state_dict()}, 0, opt=opt)
        writer = SummaryWriter(opt.tensorboard)

        for epo in tqdm(range(start_epoch, opt.epoch + 1)):
            # ret_train = run_model(nb_kpts, net_pred, optimizer, data_loader=data_loader, opt=opt,is_train=1,epo=epo)
            # ret_train = run_model(nb_kpts, net_pred, net_guid, optimizer2, optimizer, data_loader=data_loader, opt=opt,is_train=1,epo=epo)
            ret_train = run_model12(nb_kpts, net_pred, net_guid, optimizer2, optimizer, data_loader1=data_loader1,data_loader2=data_loader2, opt=opt,is_train=1,epo=epo)
            writer.add_scalar('scalar/train', ret_train['loss_train'], epo)

            # lr_now = util.lr_decay_mine(optimizer, lr_now, 0.1 ** (1 / opt.epoch))
            lr_now = util.lr_decay_mine(optimizer, lr_now,0.99)
            # lr_log = lr_now*pow(10,-(epo-1))
            #writer.add_scalar('scalar/learning_rate', lr_log, epo)

            print('epo{}, train error: {:.3f}, lr: {:.6f}'.format(epo, ret_train['loss_train'], lr_now))
            ret_log = np.array([epo, lr_now])
            head = np.array(['epoch', 'lr'])
            for k in ret_train.keys():
                ret_log = np.append(ret_log, [ret_train[k]])
                head = np.append(head, [k])
            util.save_csv_log(opt, head, ret_log, is_create=(epo == 1))
            util.save_ckpt({'epoch': epo,
                           'lr': lr_now,
                           'err': ret_train['loss_train'],
                           'state_dict': net_pred.state_dict(),
                           'optimizer': optimizer.state_dict()},
                            epo, opt=opt)
        writer.close()

    else: #test
        # run_model(nb_kpts, net_pred, data_loader=data_loader, opt=opt, is_train=0)
        run_model(nb_kpts, net_pred, net_guid, data_loader=data_loader, opt=opt, is_train=0)

# def run_model(nb_kpts, net_pred, optimizer=None, data_loader=None, opt=None, is_train=0, epo=0):

def run_model12(nb_kpts, net_pred, net_guid, optimizer2=None, optimizer=None, data_loader1=None,data_loader2=None, opt=None, is_train=0, epo=0):
    # is_train: 0 test, 1 train, 2 val

    raw_in_n = 50 #use this fix number in dataloader to ensure the same test data when changing opt.input_n
    in_n = opt.input_n #real input len  ( <=50 )
    in_n_s = raw_in_n - in_n # input start nb.

    sup_n = opt.sup_n
    kz = opt.kernel_size
    out_n =  opt.output_n #prediction len (for test)

    n = 0
    if is_train == 1: #train
        net_pred.train()
        #remove
        net_guid.train()

        loss_train = 0
        train =0
        test = 0
        for i, (data_) in enumerate(data_loader1): # in_n + kz
            train +=1
            print("train"+str(train))

            if batch_size == 1:
                continue #when only one sample in this batch
            n += batch_size

            batch_size, seq_len, _ = data_.shape
            data_ = data_.float().cuda()

            data_A = data_[:,:,:18*3]
            data_B = data_[:,:,18*3:108]
            y = data_[:,:,108]


        for i, (data_) in enumerate(data_loader2): # in_n + kz
            print("test"+str(test))
            test +=1

            
        res_dic={"loss_train" : 2}
        return res_dic
    

def run_model(nb_kpts, net_pred, net_guid, optimizer2=None, optimizer=None, data_loader=None, opt=None, is_train=0, epo=0):
    # is_train: 0 test, 1 train, 2 val

    raw_in_n = 50 #use this fix number in dataloader to ensure the same test data when changing opt.input_n
    in_n = opt.input_n #real input len  ( <=50 )
    in_n_s = raw_in_n - in_n # input start nb.

    sup_n = opt.sup_n
    kz = opt.kernel_size
    out_n =  opt.output_n #prediction len (for test)

    n = 0
    if is_train == 1: #train
        net_pred.train()
        #remove
        net_guid.train()

        loss_train = 0
        for i, (data_) in enumerate(data_loader): # in_n + kz

            batch_size, seq_len, _ = data_.shape
            # print(data_.shape)
            # print("Data Shape Here ~~~~~~")
            if batch_size == 1:
                continue #when only one sample in this batch
            n += batch_size

            data_ = data_.float().cuda()
            # data_ = data_[:,:,:108]
            # print(data_.shape)
            # print("BUFFER")
            data_in = data_[:, :-kz] #bz,in_n, 108
            # print(data_in.shape)
            # print("Data In shape Here~~~~")
            ### run
            # print(data_in.shape)
            #just testing
            # data_in = data_[:,:,:104]
            data_out = net_pred(data_in)[:,:,0] #bz, 2kz, 108
            # print(data_out.shape)
            # print("Data out shape here~~~~~~")
            # print(data_out.shape)
            # print("one")
            data_gt = data_[:, -kz-kz:] #len of current observation+direct output len=20
            data_gt = data_gt[:,:,:108]
            # print("data GT over here~~~~~~")
            # print(data_gt.shape)
            # print('two')
            # print(data_gt.shape)
            ## loss
            # data_gt = data_gt[:,:,104]
            # print(data_gt.shape)
            # print("GT")
            # remove this;
            loss_l = torch.mean(torch.norm((data_out- data_gt)[:,:,:54], dim=2))
            loss_f = torch.mean(torch.norm((data_out- data_gt)[:,:,54:], dim=2))
           
            labels = data_in[:,0,108]
            labels = labels.type(torch.LongTensor)
            labels = labels.cuda()
            # print(labels)
            losscross   = nn.CrossEntropyLoss()
            guideclass = net_guid(data_out)

            lossentropy = losscross(guideclass,labels)
            # loss_l = torch.mean(torch.norm((data_out- data_gt)[:,:,:54], dim=1))
            # loss_f = torch.mean(torch.norm((data_out- data_gt)[:,:,54:], dim=1))
            # loss_l = torch.mean(torch.norm((data_out- data_gt)[:,:,:52], dim=2))
            # loss_f = torch.mean(torch.norm((data_out- data_gt)[:,:,52:], dim=2))
            # powexp = epo
            # if(powexp>20):
            #     powexp=20
            # loss = loss_f + loss_l * pow(10,-(epo-1))

            loss = loss_f + loss_l

            # loss_train += loss.cpu().data.numpy() * batch_size
            # res_dic = {"loss_train" : loss_train / n }
            
            loss1 = contin_loss(data_gt[:,:,:54],data_out[:,:,:54])
            loss2 = contin_loss(data_gt[:,:,54:108],data_out[:,:,54:108])
            loss += loss1 + 4*loss2
             # 1 < 2 < 3 < 4
            loss = loss + lossentropy
            # loss1 = contin_loss(data_gt[:,:,:54].cpu().detach().numpy(),data_out[:,:,:54].cpu().detach().numpy())
            # loss2 = contin_loss(data_gt[:,:,54:108].cpu().detach().numpy(),data_out[:,:,54:108].cpu().detach().numpy())
            # print(np.array(loss.cpu().detach().numpy()))
            optimizer.zero_grad()
            optimizer2.zero_grad()
            loss.backward()
            loss = loss - lossentropy
            loss_train += loss.cpu().data.numpy() * batch_size
            optimizer.step()
        res_dic = {"loss_train" : loss_train / n }
        return res_dic

    else: #test
        net_pred.eval()
        #temp
        mpjpe_joi, mpjpe_ali = np.zeros([out_n]),np.zeros([out_n])
        for i, (data_) in enumerate(data_loader): # raw_in_n + out_n
            batch_size, seq_len, _ = data_.shape #raw_in_n+30
            n += batch_size
            # print(data_.shape)
            #  data_ = data_.reshape([-1, seq_len, nb_kpts*3]).float().cuda() #raw_in_n + 30
            data_ = data_.float().cuda()
            # data_ = data_.reshape([-1, seq_len, nb_kpts*3+1]).float().cuda() #raw_in_n + 30
            data_in = data_[:, in_n_s:raw_in_n] #in_n
            # print(data_in.shape)
            gt = data_[:,raw_in_n:,:108]
            # print(gt.shape)
            gt = gt.reshape(-1,30,18*2,3)
            # print(gt.shape)
            # gt = data_[:, raw_in_n:].reshape([-1, out_n, nb_kpts,3]) #out_n
            # gt = data_[:, raw_in_n:,:108].reshape([-1, out_n, 54,3]) #out_n
            # gt = gt[:,:,:108]

            # itr_test = int(out_n/kz) + 1
            itr_test = int(out_n/kz)
            pred = []
            q, w, e = data_in.shape
            for s in range(q):
                for d in range(w):
                    data_in[s][d][108]=int(6)
                    
            for itera in range(itr_test):
                # print(i)
                # print(itera)
                data_out = net_pred(data_in) #, input_n=in_n, output_n=2*kz, itera=1)#bz,10+10,1,108
                data_out = data_out[:, kz:,0] #batch_size, sup_n, nb_joints*joint_size
                pred.append(data_out)
                act_ = data_in[0,0,108]
                a , b , c = data_out.shape
                data_out_ = torch.zeros((a,b,109))
                data_out_ = data_out_.cuda()
                for i in range(a):
                    for j in range(b):
                        # print(act_)
                        temp = torch.zeros((1))
                        temp[0] = int(act_)
                        # temp[0] = int(6)
                        # print(temp)
                        temp = temp.cuda()
                        data_out_[i][j] = torch.cat((data_out[i][j],temp),0)
                #         # print(data_out_.shape)
                #         # print(data_out_[i][j][107])
                #         # print(data_out_[i][j][108])
                        
                # data_in = torch.cat((data_in[:,kz:,:108], data_out),axis=1)
                data_in = torch.cat((data_in[:,kz:], data_out_),axis=1)
            # print("HI")
            # print(len(pred))
            # print(len(pred[0]))
            # print(len(pred[0][0]))
            # print(len(pred[0][0][0]))
            pred = torch.cat(pred,axis=1)
            # print(pred.shape)
            pred = pred[:,:30,:]
            # print(pred.shape)
            pred = pred.reshape([-1,30,18*2,3])
            nb_kpts = 18*2
            data_ = data_[:,:,:108]
            # pred = torch.cat(pred, axis=1)[:,:out_n].reshape([-1, out_n, nb_kpts, 3]) #batch_size, out_len, nb_joints, joint_size
            # pred = torch.cat(pred, axis=1)[:,:out_n].reshape([-1, out_n, 18*2, 3]) #batch_size, out_len, nb_joints, joint_size

            ### evaluate###
            ## JME
            tmp_joi = torch.sum(torch.mean(torch.norm(gt - pred, dim=3), dim=2), dim=0)
            mpjpe_joi += tmp_joi.cpu().data.numpy()
            # opt.vis = True
            
            if opt.vis:
                # vis_2p.vis_pi_compare(data_.reshape([-1, seq_len, nb_kpts,3]).detach().cpu().numpy()[0],\
                #         pred_all.detach().cpu().numpy()[0], './outputs/example.mp4')
                vis_2p.vis_pi_compare(data_.reshape([-1, seq_len, nb_kpts,3]).detach().cpu().numpy()[0],
                        pred.detach().cpu().numpy()[0], './outputs/example.mp4')

            ## AME
            pred_ali = pred #torch.cat((pred[:,:,int(nb_kpts/2):], data_utils.unnorm_abs2Indep(pred[:,:,:int(nb_kpts/2)])), axis=2)
            gt_ali = gt #torch.cat((gt[:,:,int(nb_kpts/2):], data_utils.unnorm_abs2Indep(gt[:,:,:int(nb_kpts/2)])), axis=2)

            pred_ali_l = rigid_align_torch(pred_ali[:,:,:int(nb_kpts/2)], gt_ali[:,:,:int(nb_kpts/2)])
            pred_ali_f = rigid_align_torch(pred_ali[:,:,int(nb_kpts/2):], gt_ali[:,:,int(nb_kpts/2):])
            pred_ali = torch.cat((pred_ali_l,pred_ali_f), axis=2)

            tmp_ali = torch.sum(torch.mean(torch.norm(gt_ali - pred_ali, dim=3), dim=2), dim=0)
            mpjpe_ali += tmp_ali.cpu().data.numpy()

        mpjpe_joi, mpjpe_ali = mpjpe_joi/n, mpjpe_ali/n  # n = testing dataset length

        out_print_frame = [4,9,14,19,24]
        res_dic = {"mpjpe_joi": mpjpe_joi[out_print_frame],
                   "mpjpe_ali": mpjpe_ali[out_print_frame]}
        print('Error at each output frame:\n Frame number:{}\n Error:{}'.format(out_print_frame,res_dic))

        opt.save_results = False
        if opt.save_results:
            # save result of all experiments together to easier generate the result tables.
            import json
            results = json.load(open('../outputs/results.json', 'r'))
            key_exp = opt.exp+ '_testepo'+str(opt.test_epo)
            print('save name exp:', opt.exp)
            if key_exp not in results:
                results[key_exp]={}
            ts = str(opt.test_split) if opt.test_split is not None else 'AVG'
            if ts not in results[key_exp]:
                results[key_exp][ts]={}
            results[key_exp][ts]={"mpjpe_joi": mpjpe_joi.tolist(),
                                  "mpjpe_ali": mpjpe_ali.tolist()}
            with open('outputs/results.json', 'w') as w:
                json.dump(results, w)

        return res_dic


if __name__ == '__main__':
    option = Options().parse()
    main(option)



# %%
